#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <functional>
#include <bitset>
#include <deque>
#include <cmath>
#include <queue>
#include <cstdlib>
#include <stdio.h>
#include <cassert>
#include <climits>
#include <ctime>
#include <algorithm>
#include <string>

using ld = long double;
using ll = long long;
using namespace std;

const int M = int(1e9) + 7;

ll modpow(ll x, int pow) {
	ll res = 1;
	for (int i = 0; i < pow; ++i) {
		res = (res * x) % M;
	}
	return res;
}

void solve() {
	ll a, b, c, n;
	cin >> a >> b >> c >> n;
	map<ll, int> cnt;
	for (ll x = 0; x < n; ++x) {
		ll p = x * x * a + x * b + c;
		for (ll i = 2; i * i <= p; ++i) {
			if (p % i == 0) {
				while (p % i == 0) {
					p /= i;
					++cnt[i];
				}
			}
		}
		if (p > 1) {
			++cnt[p];
		}
	}
	ll ans = 1;
	for (auto p : cnt) {
		ll x = p.first;
		int pow = p.second;
		if (pow % 2 == 1) {
			--pow;
		}
		ans = ans * modpow(x, pow) % M;
	}
	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr);
	int t = 1;
	// cin >> t;
    while (t-- > 0) solve();
}