#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <sstream>
#include <functional>
#include <deque>
#include <stack>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
ll power(ll a, ll m, ll modulo)
{
	ll result = 1;
	for (ll stp = a, sm = 1; sm <= m; sm <<= 1, stp = (stp * stp) % modulo)
		if ((sm & m) != 0)
			result = (result * stp) % modulo;
	return result;
}

ll inverse_by_module(ll a, ll modulo)
{
	return power(a, modulo - 2, modulo);
}

int pop_count(ll a)
{
	int ans = 0;
	for (; a > 0; a >>= 1)
		ans += a & 1;
	return ans;
}

int count_zero(unsigned char a)
{
	int ans = 0;
	int nmb = 8;
	for (; nmb > 0; a >>= 1, nmb--)
		ans += (a & 1) == 0;
	return ans;
}

template<typename T>
int bin_search_lvalue(vector<T> const& mas, T const& search_value)
{
	int l = -1, r = mas.size();
	while (l < r - 1)
	{
		int m = (l + r) / 2;
		if (mas[m] < search_value)
			l = m;
		else
			r = m;
	}
	return l;
}
template<typename T>
int bin_search_rvalue(vector<T> const& mas, T const& search_value)
{
	int l = -1, r = mas.size();
	while (l < r - 1)
	{
		int m = (l + r) / 2;
		if (mas[m] <= search_value)
			l = m;
		else
			r = m;
	}
	return r;
}
ll modulo = 1000000007;
ll obr(ll a)
{
	ll m = modulo - 2;
	ll ans = 1;
	for (int i = 1; i <= m; i <<= 1)
	{
		if ((m & i) != 0)
			ans = (ans * a) % modulo;
		a = (a * a) % modulo;
	}
	return ans;
}
ll gcd(ll a, ll b)
{
	while (b != 0)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}

template <typename T>
class OtrTree
{
public:
	typedef function<T(T const&, T const&)> MergeFuncType;
	OtrTree(vector<T> const& values, MergeFuncType merge_func, T def_value=T())
	{
		mMergeFunc = merge_func;
		mDefValue = def_value;
		int bin_step = 1 << int(ceil(log2(values.size())));
		mBeginOfValues = bin_step - 1;
		mValues = vector<T>(2 * bin_step - 1, def_value);
		mLeftValues.resize(mValues.size());
		mRightValues.resize(mValues.size());
		for (int i = 0; i < values.size(); i++)
		{
			mValues[i + mBeginOfValues] = values[i];
		}
		for (int i = 0; i < bin_step; i++)
		{
			mLeftValues[i + mBeginOfValues] = mRightValues[i + mBeginOfValues] = i;
		}
		for (int i = mBeginOfValues - 1; i >= 0; i--)
		{
			CountValue(i);
			mLeftValues[i] = mLeftValues[(i << 1) + 1];
			mRightValues[i] = mRightValues[(i << 1) + 2];
		}
	}
	virtual T GetValue(const int left, const int right, int i = 0)
	{
		if (left <= mLeftValues[i] && right >= mRightValues[i])
			return mValues[i];
		if (left > mRightValues[i] || right < mLeftValues[i])
			return mDefValue;
		return mMergeFunc(GetValue(left, right, (i << 1) + 1), GetValue(left, right, (i << 1) + 2));
	}
	void UpdateValue(int number, T const& value)
	{
		number += mBeginOfValues;
		mValues[number] = value;
		do
		{
			number = (number - 1) >> 1;
			CountValue(number);
		} while (number > 0);
	}
protected:
	void CountValue(int number)
	{
		mValues[number] = mMergeFunc(mValues[(number << 1) + 1], mValues[(number << 1) + 2]);
	}
	MergeFuncType mMergeFunc;
	vector<T> mValues;
	vector<int> mLeftValues, mRightValues;
	int mBeginOfValues;
	T mDefValue;
};
class SumTree :public OtrTree<ll>
{
public:
	SumTree(vector<ll> const& values)
		:OtrTree(values, [](ll const& a, ll const& b) {return a + b; }, 0)
	{
		mAdd.resize(mValues.size());
	}
	ll GetValue(const int left, const int right, int i = 0) override
	{
		if (left <= mLeftValues[i] && right >= mRightValues[i])
			return mValues[i] + mAdd[i] * (ll(mRightValues[i]) - mLeftValues[i] + 1);
		if (left > mRightValues[i] || right < mLeftValues[i])
			return mDefValue;
		mAdd[(i << 1) + 1] = mAdd[(i << 1) + 2] = mAdd[i];
		mValues[i] += mAdd[i] * (ll(mRightValues[i]) - mLeftValues[i]);
		mAdd[i] = 0;
		return mMergeFunc(GetValue(left, right, (i << 1) + 1), GetValue(left, right, (i << 1) + 2));
	}
	void Add(int left, int right, ll value, int i = 0)
	{
		if (left <= mLeftValues[i] && right >= mRightValues[i])
		{
			mAdd[i] = value;
			return;
		}
		if (left > mRightValues[i] || right < mLeftValues[i])
			return;
		Add(left, right, value, (i << 1) + 1);
		Add(left, right, value, (i << 1) + 2);
		mValues[i] = SumElem((i << 1) + 1) + SumElem((i << 1) + 2);
	}
private:
	ll SumElem(int i)
	{
		return mValues[i] + mAdd[i] * (ll(mRightValues[i]) - mLeftValues[i] + 1);
	}
	vector<ll> mAdd;
};
int main()
{
	int n;
	cin >> n;
	vector<unsigned char> plt(n);
	for (int i = 0; i < n; i++)
	{
		string s;
		cin >> s;
		unsigned char res = 0;
		for (auto& symb : s)
		{
			res = (res << 1) + (symb == 'W');
		}
		plt[i] = res;
	}
	vector<bool> dp(n, false);
	dp[n - 1] = 1;
	for (int i = n - 2; i >= 0; i--)
	{
		bool sm = true;
		for (int j = 1; j < min(n - i, 9); j++)
		{
			if (count_zero(plt[i] ^ plt[i + j]) >= j)
				sm &= !dp[i + j];
		}
		dp[i] = sm;
	}
	for (int i = n - 1; i >= 0; i--)
		cout << dp[i] + 1;
	return 0;
}