#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
using namespace std;

const int mod = 1000000007;

struct coord {
    int x, y;
};

struct triangle {
    coord a, b, c;
};

long long bin_pow(long long base, long long p) {
    if (p == 1) {
        return base;
    }

    if (p % 2 == 0) {
        long long t = bin_pow(base, p / 2);
        return t * t % mod;
    }
    else {
        return bin_pow(base, p - 1) * base % mod;
    }
}

long long inv_el(long long n) {
    return bin_pow(n, mod - 2);
}

long long divide(long long a, long long b) {
    return a * inv_el(b) % mod;
}

long long C(int n, int k) {
    long long res = 1;
    for (long long i = 1; i <= k; ++i) {
        long long  t = res * (n - k + i) % mod;
        res = divide(t, i);
        res = res % mod;
        if (res < 0) res += mod;
    }
    return (long long)(res + 0.01);
}

long long pascal(int i, int j) {

    long long rez = 1;

    if (i == j || -i == j) return 1;
    long long m = (j + i) / 2;

    if (m == 1 || m == j - 1) return j;

    return C(j, m);
}

bool is_included(triangle t, coord z) {

    int a = (t.a.x - z.x) * (t.b.y - t.a.y) - (t.b.x - t.a.x) * (t.a.y - z.y);
    int b = (t.b.x - z.x) * (t.c.y - t.b.y) - (t.c.x - t.b.x) * (t.b.y - z.y);
    int c = (t.c.x - z.x) * (t.a.y - t.c.y) - (t.a.x - t.c.x) * (t.c.y - z.y);

    if ((a >= 0 && b >= 0 && c >= 0) || (a <= 0 && b <= 0 && c <= 0)) return true;
    else return false;
}

bool intersection(coord a, coord b, int n) {

    int Ua, Ub, num_a, num_b, d;

    d = (n) * (a.x - b.x) - (n) * (a.y - b.y);
    if (d == 0) {
        if ((a.x * b.y - b.x * a.y) * (n)  == 0 )
            return true;
        else return false;
    }
    else {
        num_a = (n - b.x) * n - n * (n - b.y);
        num_b = (a.x - b.x) * (n - b.y) - (n - b.x) * (a.y - b.y);
        Ua = num_a / d;
        Ub = num_b / d;
        return (Ua >= 0 && Ua <= 1 && Ub >= 0 && Ub <= 1 ? true : false);
    }
}

int counter(triangle t) {

    long long sum = 0;

    int x_min = min(t.a.x, min(t.b.x, t.c.x));
    int x_max = max(t.a.x, max(t.b.x, t.c.x));

    int y_min = min(t.a.y, min(t.b.y, t.c.y));
    int y_max = max(t.a.y, max(t.b.y, t.c.y));

    if (y_max < 0) return 0;
    
   

    int border = max(x_max, y_max);

    if (!(intersection(t.a, t.b, border)|| intersection(t.c, t.b, border) || intersection(t.a, t.c, border))) return 0;

    int border_lower = max(0, y_min);

    for (int i = border_lower; i <= border; ++i) {
        int left = max(-i, x_min);
        if (i % 2 == 0 && left % 2 != 0 || i % 2 != 0 && left % 2 == 0)left++;
        int right = min(i, x_max);

        //cout << i << " " << left << " " << right<<endl;

        for (int j = left; j <= right; j += 2) {
            coord z;
            z.x = j; z.y = i;
            if (is_included(t, z)) {
                sum += (pascal(j, i) % mod);
                sum %= mod;
            }
        }
    }

    return sum;
}

void solve() {
    int n;

    cin >> n;

    triangle t;

    for (int i = 0; i < n; ++i) {
        cin >> t.a.x >> t.a.y;
        cin >> t.b.x >> t.b.y;
        cin >> t.c.x >> t.c.y;

        cout << counter(t) % mod << endl;
    }
}

int main() {

    solve();
    /*
    freopen("output.txt", "w", stdout);

    for (int i = 999999; i <= 1000000; ++i) {
        int j = 0;
        if (i % 2 == 1) j++;
        cout << (pascal(j, i) % mod)<<", ";
    }*/
   
    return 0;
}