// chrono::system_clock::now().time_since_epoch().count()
#include <bits/stdc++.h>

#define pb push_back
#define eb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define debug(x) cerr << #x << " = " << x << endl

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int MAXN = (int)1e6 + 5;
const int MAXM = (int)2e6 + 5;
const int INF = (int)1e9;

int fenw[MAXM];
array<int, 3> que[MAXN];
int ans[MAXN];
int lc[MAXN], rc[MAXN], myval[MAXN];
int lval[MAXN], rval[MAXN];
vector<array<int, 4>> events;
int n, m, q;

void dfs(int v) {
    lval[v] = rval[v] = myval[v];
    
    if (lc[v]) {
        dfs(lc[v]);
        lval[v] = min(lval[v], lval[lc[v]]);
    }
    
    if (rc[v]) {
        dfs(rc[v]);
        rval[v] = max(rval[v], rval[rc[v]]);
    }
    
    //cout << v << ' ' << lval[v] << ' ' << rval[v] << endl;
}

bool bad1(int v, int l, int r) {
    return l <= lval[v] && rval[v] <= r;
}

bool bad2(int v, int l, int r) {
    return rval[v] < l;
}

bool bad3(int v, int l, int r) {
    return lval[v] > r;
}

bool ok(int v, int l, int r) {
    return !bad1(v, l, r) && !bad2(v, l, r) && !bad3(v, l, r);
}

void addRect(int x1, int x2, int y1, int y2) {
    events.pb({x1, y1, y2, 1});
    events.pb({x2 + 1, y1, y2, -1});
}

void go(int v, int pr = -1) {
    if (!v) {
        return;
    }
    
    addRect(-INF, lval[v], rval[v], INF);
    addRect(rval[v] + 1, INF, -INF, INF);
    addRect(-INF, INF, -INF, lval[v] - 1);
    go(lc[v], v);
    go(rc[v], v);
}

void compress() {
    vi pts;
    
    for (auto it : events) {
        pts.pb(it[1]);
        pts.pb(it[2]);
    }
    
    rep (i, 1, q + 1) {
        pts.pb(que[i][1]);
    }
    
    sort(all(pts));
    pts.resize(unique(all(pts)) - pts.begin());
    m = sz(pts);
    
    for (auto &it : events) {
        it[1] = upper_bound(all(pts), it[1]) - pts.begin();
        it[2] = upper_bound(all(pts), it[2]) - pts.begin();
    }
    
    rep (i, 1, q + 1) {
        que[i][1] = upper_bound(all(pts), que[i][1]) - pts.begin();
    }
}

int fenwPref(int p) {
    int ret = 0;
    
    for (; p > 0; --p) {
        ret += fenw[p];
        p &= (p + 1);
    }
    
    return ret;
}

void fenwUpd(int p, int x) {
    for (; p <= m; p |= (p + 1)) {
        fenw[p] += x;
    }
}

void solve() {
    cin >> n;
    
    rep (i, 1, n + 1) {
        cin >> lc[i] >> rc[i] >> myval[i];
    }
    
    dfs(1);
    cin >> q;
    
    for (int i = 1; i <= q; ++i) {
        int x, y;
        cin >> x >> y;
        que[i] = {x, y, i};
        ans[i] = (n - 1) * 2;
    }
    
    for (int i = 1; i <= q; ++i) {
        if (ok(1, que[i][0], que[i][1])) {
            ans[i] += 3;
        }
        else {
            ans[i]++;
        }
    }
    
    go(lc[1]);
    go(rc[1]);
    sort(all(events));
    sort(que + 1, que + q + 1);
    compress();
    
    int ptr = 0;
    
    for (int i = 1; i <= q; ++i) {
        while (ptr < sz(events) && events[ptr][0] <= que[i][0]) {
            int l = events[ptr][1], r = events[ptr][2], w = events[ptr][3];
            fenwUpd(l, w);
            fenwUpd(r + 1, -w);            
            ++ptr;
        }
        
        ans[que[i][2]] -= 2 * fenwPref(que[i][1]);
    }
    
    for (int i = 1; i <= q; ++i) {
        cout << ans[i] << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    
    while (tt--) {
        solve();
    }

    return 0;
}
