#include <bits/stdc++.h>

#define XA(X) X.begin(),X.end()
#define XE(A,B) for (int A = 0; A < (B); A++)
#define XI(F,V,C) V = F(V,C)
#define XL(X) #X << "=" << X << " "

#define M_PI 3.14159265358979323846

using namespace std;

typedef long long int i64;
typedef long double ld;

const int S = 2*1024*1024;
const i64 INF = 2e18+5;
const int MOD = 1000*1000*1000 + 7;
const ld EPS = 0.00000000001;
const i64 ENC = 1024*1024;

const bool LOCAL = false;

const int NONE = -42;

template<typename T> struct base_point {
    T x, y;

    base_point<T>() {

    }

    base_point<T>(T x, T y) {
        this->x = x;
        this->y = y;
    }

    void read() {
        cin >> x >> y;
    }

    pair<T, T> as_pair() {
        return make_pair(x, y);
    }

    T get_a() {
        return y-x;
    }

    base_point<T> operator+(base_point<T> &other) {
        return base_point<T>(x+other.x, y+other.y);
    }

    base_point<T> operator+(base_point<T> &&other) {
        return base_point<T>(x+other.x, y+other.y);
    }

    base_point<T> operator-(base_point<T> &other) {
        return base_point<T>(x-other.x, y-other.y);
    }

    base_point<T> operator-(base_point<T> &&other) {
        return base_point<T>(x-other.x, y-other.y);
    }


    base_point<T> operator*(T scalar) {
        return base_point<T>(x*scalar, y*scalar);
    }

    base_point<T> rotate90() {
        return base_point<T>(-y, x);
    }

    base_point<T> rotate(T angle) {
        return base_point<T>(
            cosl(angle) * x - sinl(angle) * y,
            cosl(angle) * y + sinl(angle) * x
        );
    }

    bool in_first_quadrant() {
        return (x >= 0 && y > 0);
    }

    T operator*(base_point<T> &other) {
        return x*other.x + y*other.y;
    }

    T operator%(base_point<T> &other) {
        return x*other.y - y*other.x;
    }

    T operator%(base_point<T> &&other) {
        return x*other.y - y*other.x;
    }

    bool operator<(base_point<T> &other) {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }

    bool operator==(base_point<T> &other) {
        return (x == other.x) && (y == other.y);
    }

    bool operator==(base_point<T> &&other) {
        return (x == other.x) && (y == other.y);
    }

    bool operator!=(base_point<T> &other) {
        return (x != other.x) || (y != other.y);
    }

    bool operator!=(base_point<T> &&other) {
        return (x != other.x) || (y != other.y);
    }

    T norm() {
        return x*x + y*y;
    }

    T len() {
        return sqrtl(norm());
    }

};

typedef base_point<i64> point;

mt19937 mt_rand(time(0));

struct mre {
    int v;

    mre() {
        v = 0;
    }

    mre (int nv) {
        v = nv%MOD;
    }

    mre (i64 nv) {
        v = nv%MOD;
    }

    mre operator+(mre other) {
        int r = (v+other.v)%MOD;

        return mre(r);
    }

    mre operator-(mre other) {
        return mre(v) + other.neg();
    }

    mre operator*(mre other) {
        int r = (v*(i64)other.v)%MOD;

        return mre(r);
    }

    mre neg() {
        if (v == 0) return mre(0);

        return mre(MOD-v);
    }

    bool operator ==(mre& other) {
        return v == other.v;
    }

    bool operator ==(mre&& other) {
        return v == other.v;
    }

    mre bpow(int e) {
        if (e == 0) return mre(1);

        mre sq = mre(v)*mre(v);
        if (e & 1) {
            return sq.bpow(e/2) * mre(v);
        } else {
            return sq.bpow(e/2);
        }
    }

    mre inv() {
        return mre(v).bpow(MOD-2);
    }

    bool operator<(const mre& other) {
        return v < other.v;
    }

};

void fail() {
    cout << "NO" << endl;
    exit(0);
}

vector<i64> y_by_a[S];

mre fact[2][S];

void prepare_fact() {
    fact[0][0] = mre(1);
    XE(i,S-1) fact[0][i+1] = fact[0][i] * mre(i+1);

    int last = S-1;

    fact[1][last] = fact[0][last].inv();

    for (int i = last-1; i >= 0; i--) fact[1][i] = fact[1][i+1] * mre(i+1);


    /*

    XE(i,20) {
        mre cm = fact[0][i] * fact[1][i];

        cout << XL(i) << XL(fact[0][i].v) << XL(fact[1][i].v) << XL(cm.v) << endl;
    }

    //*/
}

mre binom(int u, int d) {
    if (d < 0) return mre(0);
    if (u-d < 0) return mre(0);

    return fact[0][u] * fact[1][d] * fact[1][u-d];
}

/// sum for i = [0;k) binom(i,k)
mre binom_prefix(int u, int d) {
    return binom(u, d+1);
}


i64 sgn(i64 v) {
    if (v > 0) return 1;
    if (v < 0) return -1;

    return 0;
}

struct segm {
    point s;
    point e;

    point ov;

    i64 xmax;
    i64 xmin;
    i64 ymax;
    i64 ymin;

    segm() {

    }

    segm(point s, point e) {
        this->s = s;
        this->e = e;

        ov = (e-s);

        xmax = max(s.x, e.x);
        ymax = max(s.y, e.y);

        xmin = min(s.x, e.x);
        ymin = min(s.y, e.y);
    }

    bool in_bound_box(point p) {
        return
            xmin <= p.x && p.x <= xmax &&
            ymin <= p.y && p.y <= ymax;
    }

    i64 dir(point p) {
        return sgn((p-s) % (ov));
    }


};



point a,b,c;

void calc_bounds(point ps, point pe) {
    segm s(ps, pe);

    //cout << XL(ps.x) << XL(ps.y) << XL(pe.x) << XL(pe.y) << endl;

    i64 amin = min(s.s.get_a(), s.e.get_a());
    i64 amax = max(s.s.get_a(), s.e.get_a());

    //cout << XL(amin) << XL(amax) << endl;

    /// special case amin == amax can be ignored
    if (amin == amax) {
        return;
    }

    point pos_dir(s.xmax+S, s.ymax+S);

    i64 pos_dir_sgn = s.dir(pos_dir) ;


    /// general case
    point p;
    p = s.s;
    if (s.e.get_a() == amin) {
        p = s.e;
    }

    for (i64 a = amin; a <= amax; a++) {

        while (s.dir(p)*pos_dir_sgn == 1) {
            p.y--;
            p.x--;
        }

        while (s.dir(p)*pos_dir_sgn < 1) {
            p.y++;
            p.x++;
        }

        if (a >= 0) {
            y_by_a[a].push_back(p.y);
        }

        //cout << XL(a) << XL(p.x) << XL(p.y) << endl;

        p.y++;
    }
}

void solvet() {
    XE(a,S) y_by_a[a].clear();

    a.read();
    b.read();
    c.read();

    /// solve

    calc_bounds(a,b);
    calc_bounds(b,c);
    calc_bounds(c,a);

    mre ans = mre(0);

    for (i64 a = 0; a < S; a += 2) {
        vector<i64>& q = y_by_a[a];

        if (q.size() == 0) continue;

        assert(q.size() >= 2);


        sort(q.begin(), q.end());

        i64 yl = *q.begin();
        i64 yr = *q.rbegin();



        yl -= 0;
        yr -= 0;


        ans = ans
            + binom_prefix(yr, a/2)
            - binom_prefix(yl, a/2);

        //cout << XL(a) << XL(yl) << " " << (yl) << " " <<  (a/2) << " " << XL(binom_prefix(yl, a/2).v) << endl;
        //cout << XL(a) << XL(yr) << " " << (yr) << " " <<  (a/2) << " " << XL(binom_prefix(yr, a/2).v) << endl;
    }

    cout << ans.v << endl;
}

void solve() {
    prepare_fact();

    //XE(k, 5) XE(n, 5) cout << XL(n) << XL(k) << binom_prefix(n,k).v << endl;;

    int tq;
    cin >> tq;

    XE(tqc, tq) {
        solvet();
    }

}

/*


1
0 0 -3 3  3 3

2
0 -1 -4 3 4 3
5 4 0 1 3 -2

//*/

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cout << fixed;
    cout.precision(20);

    solve();
}

