#pragma region template
#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:65536000")
#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cmath>
using namespace std;

const double eps = 1e-9;
const double pi = 3.141592653589793238462643383279502884;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef pair<double, double> pdd;
typedef pair<string, string> pss;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define ff first
#define ss second

#define fi(n) for (int i = 0; i < (int)(n); ++i)
#define fir(l, r) for (int i = (int)(l); i < (int)(r); ++i)
#define fj(n) for (int j = 0; j < (int)(n); ++j)
#define fjr(l, r) for (int j = (int)(l); j < (int)(r); ++j)

#pragma endregion

bool DEBUG = false;

pair<pii, pii> split(int a, int b) {
    int a1 = 0, b1 = 0, a2 = 0, b2 = 0;
    b1 = b / 2;
    b2 = b / 2 + b % 2;
    if (b1 == b2) {
        a1 = a / 2;
        a2 = a / 2 + a % 2;
    }
    else {
        if (a > 0)
            a1++, a--;
        a1 += a / 2 + a % 2;
        a2 += a / 2;
    }
    if (abs((a1 + b1 * 2) - (a2 + b2 * 2)) > 1)
        return { {-1, -1}, {-1, -1} };
    return { {a1, b1}, {a2, b2} };
}

vector<vector<int>> dfs(int a, int b, int start_with) {
    if (DEBUG) {
        cout << a << ' ' << b << ' ' << start_with << '\n';
    }
    if (a == 0 && b == 0)
        return {};
    if (a == 1 && b == 0)
        return { {1, 0, 0, start_with} };
    if (a == 0 && b == 1)
        return { {2, 0, 0, start_with} };
    int root = 2;
    if (b > 0)
        b--;
    else {
        a--;
        root = 1;
    }
    auto ab = split(a, b);
    if (ab.ff.ff == -1)
        return {};
    int root_left = start_with + 1;
    int root_right = start_with + 1 + (ab.ff.ff + ab.ff.ss);
    int size_left = ab.ff.ff + ab.ff.ss;
    int size_right = ab.ss.ff + ab.ss.ss;
    auto solve1 = dfs(ab.ff.ff, ab.ff.ss, root_left);
    auto solve2 = dfs(ab.ss.ff, ab.ss.ss, root_right);
    if (solve1.size() == 0 && size_left > 0)
        return {};
    if (solve2.size() == 0 && size_right > 0)
        return {};
    vector<vector<int>> ans;
    ans.push_back({ root, solve1.size() > 0 ? root_left : 0, solve2.size() > 0 ? root_right : 0, start_with });
    for (auto vec : solve1)
        ans.push_back(vec);
    for (auto vec : solve2)
        ans.push_back(vec);
    return ans;
}

void solve() {
    int a, b;
    cin >> a >> b;
    vector<vector<int>> ans(a + b);
    for (auto vec : dfs(a, b, 1)) {
        ans[vec[3] - 1] = { vec[0], vec[1], vec[2] };
    }
    if (ans[0].size() == 0) {
        cout << -1;
    }
    else {
        for (auto vec : ans) {
            cout << vec[0] << ' ' << vec[1] << ' ' << vec[2] << '\n';
        }
    }
}


int main()
{
    cin.sync_with_stdio(0);
    solve();
    return 0;
}
/*


*/