	#define _CRT_SECURE_NO_WARNINGS
	#include<iostream>
	#include <vector>
	#include <map>
	#include <string>
	#include<unordered_map>
	#include <unordered_set>
	#include<set>
	#include<queue>
	#include<iomanip>
	#include <bitset>
	typedef long long ll;
	using namespace std;
	const int MAXN = 2e5 + 10;
	const int LOGN = 20;
	int numbers[MAXN];
	int values[MAXN];
	int min_values[MAXN];
	int max_values[MAXN];
	int l[MAXN], r[MAXN];
	int p[MAXN][LOGN];
	int h[MAXN];
	int l_item[MAXN], r_item[MAXN];
	vector<int> kekw;
	

	void dfs(int v, int parent)
	{
		if (l[v] == -1 && r[v] == -1)
			kekw.push_back(v);

		
		h[v] = h[parent] + 1;
		p[v][0] = parent;
		for (int i = 1; i < LOGN; ++i)
		{
			p[v][i] = p[p[v][i - 1]][i - 1];
		}
		min_values[v] = values[v];
		max_values[v] = values[v];
		if (l[v] != -1)
		{
			dfs(l[v], v);
			min_values[v] = min_values[l[v]];
		}
		
		if (r[v] != -1)
		{
			dfs(r[v], v);
			max_values[v] = max_values[r[v]];
		}
	}

	int get_parent(int v, int to)
	{
		if (h[v] < h[to])
			swap(v, to);
		for (int i = 0; i < LOGN; ++i)
		{
			if ((h[v] - h[to]) & (1 << i))
			{
				v = p[v][i];
			}
		}
		if (v == to)
			return v;
		for (int i = LOGN - 1; i >= 0; --i)
		{
			if (p[v][i] != p[to][i])
			{
				v = p[v][i];
				to = p[to][i];
			}
		}
		return p[v][0];
	}

	bool contain(int l, int r, int l1, int r1)
	{
		return l >= l1 && r <= r1;
	}

	
bool intersect(int l1, int r1, int l, int r)
{
	return max(l1, l) <= min(r1, r);
}

int GetFirstValue(int v, int l, int r)
{
	if (!intersect(min_values[v], max_values[v], l, r))
	{
		for (int i = LOGN - 1; i >= 0; --i)
		{
			
			int p_val = p[v][i];
			if (!intersect(min_values[p_val], max_values[p_val], l, r))
			{
				v = p_val;
			}
		}
		if (v == 0)
			return -1;
		v = p[v][0];
	}
	if (!contain(min_values[v], max_values[v], l, r))
		return v;
	for (int i = LOGN - 1; i >= 0; --i)
	{

		int p_val = p[v][i];
		if (contain(min_values[p_val], max_values[p_val], l, r))
		{
			v = p_val;
		}
	}
	if (v == 0)
		return -1;
	return p[v][0];
}
	

	void solve()
	{
		int n;
		cin >> n;
		for (int i = 0; i < n; ++i)
		{
			cin >>l[i] >> r[i] >> values[i];
			l[i]--;
			r[i]--;
		}
		dfs(0, 0);
		
		int q;
		cin >> q;
		
		for (int i = 0; i < q; ++i)
		{
			int l, r;
			cin >> l >> r;
			int l_index = 0, r_index = kekw.size() - 1;
			while (l_index < r_index)
			{
				int med = (l_index + r_index) >> 1;
				if (values[kekw[med]] >= l)
					r_index = med;
				else
					l_index = med + 1;
			}
			int m = GetFirstValue(kekw[l_index], l, r);
			if (m == -1)
			{
				cout << 1 << '\n';
				continue;
			}
			if (l_index > 0)
			{
				int v = GetFirstValue(kekw[l_index - 1], l, r);

				if (get_parent(v, m) != v)
				{
					m = v;
				}
			}
			l_index = 0, r_index = kekw.size() - 1;
			while (l_index < r_index)
			{
				int med = (l_index + r_index + 1) >> 1;
				if (values[kekw[med]] <= r)
					l_index = med;
				else
					r_index = med - 1;
			}
			int c = GetFirstValue(kekw[l_index], l, r);
			if (l_index < kekw.size() - 1)
			{
				int v = GetFirstValue(kekw[l_index + 1], l, r);
				if (get_parent(v, c) != v)
				{
					c = v;
				}
			}
			
			cout << 2 * (h[c] + h[m]  - h[get_parent(c, m)]) + 1 << '\n';
		}

	}


	int main()
	{
//		freopen("input.in", "r", stdin);
//		freopen("output.out", "w", stdout);

		solve();
		return 0;
	}