#include <algorithm>
#include <queue>
#include <deque>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>
#include <cstring>
#include <cmath>
#include <stack>
#include <random>


using namespace std;
using ll = long long;
#define forn(i, n) for(ll i = 0; i < n; ++i)

const ll INF = 1e9;
const ll MOD = 1e17;
const ll MAXN = 2 * 1e5 + 100;
const ll MAXL = 20;

vector<pair<int, int> > graph;
vector<int> weight;
int cnt = 1;

int build(int a, int b) {
    if (a == 0 && b == 0) {
        return 0;
    }
    if (a == 0 && b % 2 == 0) {
        return -1;
    }
    int left, right;
    if (b == 0) {
        --a;
        left = build((a + 1) / 2, 0);
        right = build(a / 2, 0);
        weight.push_back(1);
    } else {
        --b;
        if (b % 2 == 1) {
            if (a % 2 == 0) {
                left = build(a / 2 - 1, (b + 1) / 2);
                right = build(a / 2 + 1, b / 2);
            } else {
                left = build(a / 2, (b + 1) / 2);
                right = build((a + 1) / 2, b / 2);
            }
        } else {
            left = build((a + 1) / 2, b / 2);
            right = build(a / 2, b / 2);
        }
        weight.push_back(2);
    }
    if (left == -1 || right == -1) {
        return -1;
    }
    graph.push_back({left, right});
    return cnt++;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0),cout.tie(0);
    cout << fixed << setprecision(16);
#ifdef LOCAL
    freopen("input.in", "r", stdin);
#endif
    int a, b;
    cin >> a >> b;
    int r = build(a, b);
    if (r == -1) {
        cout << -1 << '\n';
    } else {
        reverse(weight.begin(), weight.end());
        reverse(graph.begin(), graph.end());
        for (int i = 0; i < graph.size(); ++i) {
            cout << weight[i] << ' ';
            int a = graph[i].first;
            int b = graph[i].second;
            if (a != 0) {
                a = cnt - a;
            }
            if (b != 0) {
                b = cnt - b;
            }

            cout << a << " " << b << '\n';
        }
    }
    return 0;
}