#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#pragma comment(linker, "/STACK:66777216")
#include <iostream>
#include <algorithm>
#include <queue>
#include <functional>
#include <vector>
#include <string>
#include <assert.h>
#include <map>
#include <set>
#include <iomanip>
#include <random>
#include <chrono>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef long double ld;

mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int MAX_N = 1e5 + 1;

bool selected[MAX_N];

vector<int> persons[MAX_N];
vector<int> days[MAX_N];
vector<int> g[MAX_N];
vector<int> tops_sort;
int dp[MAX_N];

void dfs1(int u)
{
	if (selected[u])
		return;
	selected[u] = 1;
	dp[u] = 1;
	for (auto v : g[u])
	{
		dfs1(v);
		dp[u] = max(dp[v] + 1, dp[u]);
	}
}

void dfs(int u)
{
	if (selected[u])
		return;
	selected[u] = 1;
	for (auto v : g[u])
		dfs(v);
	tops_sort.push_back(u);
}

void solve()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		for (int j = 0; j < k; j++)
		{
			int id;
			cin >> id;
			id--;
			persons[i].push_back(id);
			days[id].push_back(i);
		}
	}

	for (int i = 0; i < MAX_N; i++)
	{
		if (1 < days[i].size())
			for (int j = 0; j < days[i].size() - 1; j++)
				g[days[i][j]].push_back(days[i][j + 1]);
	}

	memset(selected, 0, sizeof selected);
	for (int i = 0; i < n; i++)
		dfs(i);
	memset(selected, 0, sizeof selected);
	for(auto v : tops_sort)
		dfs1(v);
	int ans = 0;
	for (int i = 0; i < n; i++)
		ans = max(ans, dp[i]);
	cout << ans;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	solve();
	return 0;
}