#include <iostream>

using namespace std;

struct node { // узел дерева
    int key;
    node *left, *right;
    int min, max;
    int count;
};

struct info { //входная инфа о дереве
    int li;
    int ri;
    int ki;
};

int num; //скока раз вызвалось

int lookup(node *v, int L, int R) { // функция из условия
    num++;
    if(v == nullptr) {
        return 0;
    }
    if(L <= v->min && v->max <= R){
        return v->count;
    }
    if(v->max < L || R < v->min){
        return 0;
    }
    int res = 0;
    if(L <= v->key && v->key <= R) {
        res += 1;
    }
    res += lookup(v->left, L, R);
    res += lookup(v->right, L, R);
    return res;
}

info *mas; // массив с инфой о дереве
node *tree; // дерево

node* maketree(int ind) { // создаем дерево по данным из массива
    if(ind == 0) {
        return nullptr;
    }
    node *x = new node;
    x->key = mas[ind-1].ki;

    x->left = maketree(mas[ind-1].li);
    x->right = maketree(mas[ind-1].ri);
    x->count = 0;
    x->max = -1;
    x->min = INT32_MAX;
    return x;
}

int most_left(node *ptr){ //самый левый - наименьший
    while(ptr->left != nullptr) {
        ptr = ptr->left;
    }
    return ptr->key;
}

int most_right(node *ptr){ // самый правый - наибольший
    while(ptr->right != nullptr) {
        ptr = ptr->right;
    }
    return ptr->key;
}

int count_nodes(node *ptr) { // скока узлов в дереве с корнем PTR
    //вот тут тупость, два раза проходим вместо одного
    if(ptr == nullptr)
        return 0;
    ptr->max = most_right(ptr);
    ptr->min = most_left(ptr);
    ptr->count = count_nodes(ptr->left) + count_nodes(ptr->right) + 1; //вот тут
    return ptr->count; //и вот тут
}

int main() {
    node *bintr;
    int countnodes;
    cin >> countnodes;
    mas = new info[countnodes];

    int li, ri, ki;
    for(int i = 0; i < countnodes; i++) {
        cin >> li >> ri >> ki;
        mas[i].li = li;
        mas[i].ri = ri;
        mas[i].ki = ki;
    }

    tree = maketree(1);
    tree->count = count_nodes(tree);

    int nq;
    cin >> nq;
    for(int i = 0; i < nq; i++) {
        int L, R;
        cin >> L >> R;
        num = 0;
        lookup(tree, L, R);
        cout << num << endl;
    }
}
