﻿#include <algorithm>
#include <assert.h>
#include <chrono>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ll MOD = 1000000007;
const ld EPS = 1e-11;
const ll INFL = 1e18;
const ll INF = 1e9 + 7;
const ld PI = acos(-1);

mt19937 rnd((unsigned)chrono::steady_clock::now().time_since_epoch().count());

void app(vector<int>& curp, int ci) {
    curp.push_back(ci);
    for (int i = curp.size() - 2; i >= 0; --i) {
        curp.push_back(curp[i]);
    }
}

void pris(vector<int>& allp, vector<int>& curp) {
    for (int i = 0; i < curp.size(); ++i) {
        allp.push_back(curp[i]);
    }
}

void dfs(int ci, bool& good, vector<int>& allp, vector<int>& curp, const vector<vector<int>>& r) {
    //cout << ci << " ";
    allp.push_back(ci);
    if (!good) {
        reverse(curp.begin(), curp.end());
    }
    pris(allp, curp);
    good = false;

    for (int i = 0; i < r[ci].size(); ++i) {
        dfs(r[ci][i], good, allp, curp, r);
    }

    if (!good) {
        reverse(curp.begin(), curp.end());
        good = true;
    }
    if (r[ci].size() == 0) {
        app(curp, ci);
    }
    else {
        curp.push_back(ci);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    vector<vector<int>> r(n + 2);
    for (int i = 0; i < n - 1; ++i) {
        int root;
        cin >> root;
        r[root].push_back(i + 2);
    }

    vector<int> allp, curp;
    bool good = true;
    dfs(1, good, allp, curp, r);

    cout << allp.size() - 1 << "\n";
    for (int i = 1; i < allp.size(); ++i) {
        cout << allp[i] << " ";
    }
    cout << "\n";

    return 0;
}