#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 300500;
const int inf = 1e9;

string a[maxn];
vector<int> edge[maxn];

int Calc(int idx1, int idx2) {
    int ans = 0;
    for (int i = 0; i < 8; ++i) {
        ans += a[idx1][i] == a[idx2][i];
    }
    return ans;
}

int CalcFairMask(int idx) {
    int res = 0;
    for (int i = idx - 1; i >= max(0, idx - 7); --i) {
        int converted_v = idx - i;
        int flag = 0;
        for (auto to : edge[i]) {
            int converted_to = idx - to;
            if (converted_to < 0) {
                continue;
            }
            flag |= !(res & (1 << converted_to));
        }
        res |= flag * (1 << converted_v);
    }
    return res;
}

int dp1[1 << 8];
int dp2[1 << 8];

int main() {
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    // freopen("dome.in", "r", stdin);
    // freopen("dome.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j <= min(n, i + 8); ++j) {
            if (Calc(i, j) >= j - i) {
                edge[i].push_back(j);
            }
        }
    }

    for (int i = 0; i < (1 << 8); ++i) {
        dp1[i] = i & 1;
    }

    string ans;
    for (int i = 0; i < n; ++i) {
        int fair_mask = CalcFairMask(i);
        if (dp1[fair_mask] == 1) {
            ans += "1";
        } else {
            ans += "2";
        }

        if (i + 1 == n) {
            break;
        }

        for (int new_mask = 0; new_mask < (1 << 8); ++new_mask) {
            int flag = 0;
            for (auto to : edge[i]) {
                flag |= !(new_mask & (1 << (8 - (to - i))));
            }
            int mask = (new_mask >> 1) + flag * (1 << 7);
            dp2[new_mask] = dp1[mask];
        }
        for (int j = 0; j < (1 << 8); ++j) {
            dp1[j] = dp2[j];
        }
    }
    cout << ans << endl;
}