///#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
///#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,avx,avx2,tune=native")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

/*
    zet:
        find_by_order(k): k-stat [k > 0]
        order_of_key(k) : {el < k}

    gp_hash_table<key, val, custom_hash>

    rope<T>:
        iterators: mutable_begin, ..
        methods  : erase, insert, substr, ..
*/

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define em_back emplace_back
#define sqrt(x) sqrt(abs(x))
#define makeunique(x) sort(all(x)), x.erase(unique(all(x)), x.end())

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

template<typename T>
using zet = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct custom_hash {
    static uint64_t splitmix64(uint64_t x) {
        // http://xorshift.di.unimi.it/splitmix64.c
        x += 0x9e3779b97f4a7c15;
        x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
        x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
        return x ^ (x >> 31);
    }

    size_t operator()(uint64_t x) const {
        static const uint64_t FIXED_RANDOM = chrono::steady_clock::now().time_since_epoch().count();
        return splitmix64(x + FIXED_RANDOM);
    }
};

mt19937 eng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 1e5 + 4;

int n;
vector<int> g[N];
map<int, vector<int> > peop;
int dp[N];

int dfs(int u) {
    int& res = dp[u];
    if (res != -1) {
        return res;
    }

    res = 1;
    for (int to : g[u]) {
        res = max(res, 1 + dfs(to));
    }
    return res;
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int id;
            cin >> id;
            peop[id].em_back(i);
        }
    }

    for (auto i : peop) {
        vector<int> u = i.second;
        for (int j = 1; j < sz(u); ++j) {
            int pa = u[j];
            int a = u[j - 1];
            g[pa].em_back(a);
        }
    }

    memset(dp, -1, sizeof dp);
    int res = 1;
    for (int i = n; i >= 1; --i) {
        res = max(res, dfs(i));
    }

    cout << res << "\n";
}

int main() {
#ifndef ONLY_HERE
    ///freopen("", "r", stdin);
    ///freopen("", "w", stdout);
#endif // ONLY_HERE
    ios::sync_with_stdio(0);
    cout.tie(0), cin.tie(0);

    int z = 1;
    /// cin >> z;

    while (z--) {
        solve();
    }

    return 0;
}

