#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <vector>
#include <queue>
#include <set>

#define E1 10
#define E2 100
#define E3 1000
#define E4 10000
#define E5 100000
#define E6 1000000
#define E7 10000000

using namespace std;

void solve();

int main() {
#ifdef MYDEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0);
    cin.sync_with_stdio(false);
    cout.precision(12);
    solve();
}

map<int, vector<int>> m;
vector<set<int> > g;

int max_depth = 1;
int was[E5];
int d[E5];
void dfs(int from, int depth) {
    was[from] = 1;
    max_depth = max(max_depth, depth);
    for (auto to : g[from]) {
        if (depth + 1 > d[to]) {
            d[to] = depth + 1;
            dfs(to, depth + 1);
        }
    }
}


void solve() {
    int n;
    cin >> n;
    g.resize(n);
    for (int day_num = 0; day_num < n; day_num++) {
        int k;
        cin >> k;
        for (int i = 0; i < k; i++) {
            int p_num;
            cin >> p_num;
            m[p_num].push_back(day_num);
        }
    }
    for (auto it : m) {
        vector<int>& days = it.second;
        for (int i = 1; i < (int)days.size(); i++) {
            int from = days[i - 1];
            int to = days[i];
            g[from].insert(to);
        }
    }

    for (int start = 0; start < n; start++) {
        if (was[start] == 0) {
            dfs(start, 1);
            for (int i = 0; i < n; i++) {
                d[i] = 0;
            }
        }
    }
    cout << max_depth;
}