// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int calc_same(string const& a, string const& b) {
	int ret = 0;
	for (int i = 0; i < 8; ++i) {
		if (a[i] == b[i]) {
			++ret;
		}
	}
	return ret;
}

void solve() {
	int n;
	cin >> n;
	vector<string> field;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		field.push_back(s);
	}
	vector<int> by_mask(1 << 8, -1), next_by_mask(1 << 8, -1);
	const int tot_mask = (1 << 8) - 1;
	vector<int> dsu(n);
	iota(dsu.begin(), dsu.end(), 0);
	auto get_root = [&](int v) {
		int mem = v;
		while (dsu[v] != v) {
			v = dsu[v];
		}
		while (dsu[mem] != mem) {
			int tmp = dsu[mem];
			dsu[mem] = v;
			mem = tmp;
		}
		return v;
	};

	auto unite = [&](int a, int b) {
		a = get_root(a);
		b = get_root(b);
		if (a == b) {
			return;
		}
		dsu[a] = b;
	};

	for (int i = n - 1; i >= 0; --i) {
		fill(next_by_mask.begin(), next_by_mask.end(), -1);
		for (int mask = 0; mask < 1 << 8; ++mask) {
			if (by_mask[mask] == -1) {
				continue;
			}
			int new_bit = 0;
			for (int j = i + 1; j <= i + 8 && j < n; ++j) {
				if (j - i <= calc_same(field[i], field[j])) {
					new_bit |= !((mask >> (j - i - 1)) & 1);
				}
			}
			int nmask = ((mask << 1) | new_bit) & tot_mask;
			if (next_by_mask[nmask] == -1) {
				next_by_mask[nmask] = by_mask[mask];
			} else {
				unite(by_mask[mask], next_by_mask[nmask]);
			}
		}
		// next_by_mask[tot_mask - 1].push_back(i);
		if (next_by_mask[tot_mask - 1] == -1) {
			next_by_mask[tot_mask - 1] = i;
		} else {
			unite(i, next_by_mask[tot_mask - 1]);
		}
		swap(by_mask, next_by_mask);
	}

	vector<int> root_ans(n, -1);
	for (int i = 0; i < 1 << 8; ++i) {
		if (by_mask[i] != -1) {
			root_ans[by_mask[i]] = i & 1;
		}
	}

	for (int i = 0; i < n; ++i) {
		if (root_ans[get_root(i)]) {
			cout << "1";
		} else {
			cout << "2";
		}
	}
	cout << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}