// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<int> val(n);
	vector<vector<int>> graph(n);
	for (int i = 0; i < n; ++i) {
		int l, r, k;
		cin >> l >> r >> k;
		--l; --r;
		val[i] = k;
		if (l != -1) {
			graph[i].push_back(l);
		}
		if (r != -1) {
			graph[i].push_back(r);
		}
	}

	vector<pii> minmax(n, {INF, -INF});

	function<void(int)> dfs = [&](int v) {
		minmax[v] = {val[v], val[v]};
		for (int to : graph[v]) {
			dfs(to);
			minmax[v].ff = min(minmax[v].ff, minmax[to].ff);
			minmax[v].ss = max(minmax[v].ss, minmax[to].ss);
		}
	};

	dfs(0);

	int q;
	cin >> q;
	vector<int> ans(q);
	ordered_set<pii> left_ends, right_ends;
	vector<tuple<int, int, int>> events;
	vector<pii> points;
	for (int i = 0; i < n; ++i) {
		// cerr << minmax[i].ff << " " << minmax[i].ss << endl;
		left_ends.insert({minmax[i].ff, i});
		right_ends.insert({minmax[i].ss, i});
		points.push_back({minmax[i].ss, minmax[i].ff});
		events.push_back({minmax[i].ss, 0, i});
	}
	vector<pii> reqs;
	for (int i = 0; i < q; ++i) {
		int l, r;
		cin >> l >> r;
		reqs.push_back({l, r});
		ans[i] = right_ends.order_of_key({l - 1, INF}) + 
			n - left_ends.order_of_key({r, INF});

		// cerr << i << " " << ans[i] << endl;

		events.push_back({r, 1, i});
	}

	sort(events.begin(), events.end());
	ordered_set<pii> qwe;
	for (auto [x, type, ind] : events) {
		// cerr << x << " " << type << " " << ind << endl;
		if (type == 0) {
			// cerr << "add " << minmax[ind].ff << " " << minmax[ind].ss << endl;
			qwe.insert({points[ind].ss, ind});
		} else {
			// cerr << "ask " << reqs[ind].ff << " " << reqs[ind].ss << " " << szof(qwe) - qwe.order_of_key({reqs[ind].ff - 1, INF}) << endl;
			ans[ind] += szof(qwe) - qwe.order_of_key({reqs[ind].ff - 1, INF});
		}
	}

	for (int num : ans) {
		int x = (n - num) * 2 + 1;
		cout << x << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}