// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const double PI = atan2(0, -1);

template<typename T>
struct point {
	T x, y;
	point(T _x, T _y) : x(_x), y(_y) {}
	template<typename T2>
	point(point<T2> other) : x(other.x), y(other.y) {}

	point<T> operator+(point<T> const& other) const {
		return point<T>(x + other.x, y + other.y);
	}

	point<T> operator-(point<T> const& other) const {
		return point<T>(x - other.x, y - other.y);
	}

	point<T> ort() const {
		return point<T>(-y, x);
	}

	point<T> operator*(T num) const {
		return point<T>(x * num, y * num);
	}

	T len2() const {
		return x * x + y * y;
	}

	double len() const {
		return sqrt(len2());
	}

	double ang() const {
		return atan2(y, x);
	}
};

template<typename T>
ostream& operator<<(ostream& o, point<T> const& p) {
	o << "(" << p.x << ", " << p.y << ")";
	return o;
}

template<typename T>
T cross(point<T> const& p1, point<T> const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

struct line {
	double a, b, c;
	line(point<int> const& p1, point<int> const& p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		c = -(a * p1.x + b * p1.y);
		double tmp = sqrt(a * a + b * b);
		a /= tmp; b /= tmp; c /= tmp;
	}

	double dist(point<double> const& p) const {
		return p.x * a + p.y * b + c;
	}

	point<double> ort() const {
		return point<double>(a, b);
	}
};

pair<point<double>, point<double>> intersection(line const& l, point<double> const& c, double r) {
	double d = l.dist(c);
	double shift = sqrt(max(0.0, r * r - d * d));
	point on_line = c - l.ort() * d;
	assert(abs(l.dist(on_line)) <= 1e-3);
	point<double> v = l.ort().ort();
	return {on_line + v * shift, on_line - v * shift};
}

double norm(double ang) {
	while (ang < -PI) {
		ang += PI * 2;
	}
	while (ang >= PI) {
		ang -= PI * 2;
	}
	return ang;
}

const double eps = 1e-9;

void solve() {
	int n, xa, ya, xb, yb;
	cin >> n >> xa >> ya >> xb >> yb;
	point<int> a(xa, ya);
	point<int> b(xb, yb);
	vector<point<int>> poly;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		poly.push_back(point<int>(x, y));
	}

	double len = (b - a).len();
	int len2 = (b - a).len2();

	double init_ang = (b - a).ang();

	double to_left = PI / 2, to_right = PI / 2;

	for (int i = 0; i < n; ++i) {
		int next = (i + 1) % n;
		ll best = 0;
		int mem = i;
		for (int j = 0; j < n; ++j) {
			ll val = cross(poly[next] - poly[i], poly[j] - poly[i]);
			if (val > best) {
				best = val;
				mem = j;
			}
		}

		if ((ll) best * best < (ll) len2 * (poly[next] - poly[i]).len2()) {
			for (int j = 0; j < n; ++j) {
				if (cross(poly[next] - poly[i], poly[j] - poly[i]) == best) {
					pair<point<double>, point<double>> qq = intersection(line(poly[i], poly[next]), poly[j], len);
					// cerr << poly[i] << " " << poly[next] << " " << poly[j] << endl;
					// cerr << qq.ff << " " << qq.ss << endl;
					double from_ang = norm((qq.ss - poly[j]).ang() - init_ang);
					double to_ang = norm((qq.ff - poly[j]).ang() - init_ang);
					// cerr << from_ang / PI * 180 << " " << to_ang / PI * 180 << endl;
					if (from_ang > -eps) {
						to_left = min(to_left, from_ang);
					}
					if (to_ang < eps) {
						to_right = min(to_right, -to_ang);
					}

					from_ang = norm((qq.ss - poly[j]).ang() - init_ang + PI);
					to_ang = norm((qq.ff - poly[j]).ang() - init_ang + PI);
					// cerr << from_ang / PI * 180 << " " << to_ang / PI * 180 << endl;
					if (from_ang > -eps) {
						to_left = min(to_left, from_ang);
					}
					if (to_ang < eps) {
						to_right = min(to_right, -to_ang);
					}
				}
			}
		}
	}
	cout << max(to_left, to_right) / PI * 180 << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}