#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

using ld = long double;

mt19937_64 mt(736736);

void gen (const int pos, const vector<vector<int>> &sons, vector<int> &ans)
{
	if (pos == int(sons.size()))
		return;

	for (int i = 0; i <= int(sons[pos].size()); i++)
	{
		const int cur = int(ans.size());
		gen(pos + 1, sons, ans);
		const int new_cur = int(ans.size());
		if (i % 2 == 1)
			reverse(ans.begin() + cur, ans.begin() + new_cur);

		if (i < int(sons[pos].size()))
			ans.push_back(sons[pos][i]);
	}
}

vector<int> dfs (const int v, const vector<vector<int>> &g)
{
	vector<vector<int>> sons;
	for (const int dest : g[v])
	{
		sons.emplace_back(dfs(dest, g));
//		cnts.emplace_back(int(sons.back().size()));
	}

	vector<int> ans;
	gen(0, sons, ans);

	ans.insert(ans.begin(), v);
	return ans;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;
	cin >> n;

	vector<int> p(n);
	vector<vector<int>> g(n);

	for (int i = 1; i < n; i++)
	{
		int &it = p[i];
		cin >> it;
		--it;
		if (it >= 0)
			g[it].push_back(i);
	}

	auto res = dfs(0, g);
	assert(!res.empty());
	res.erase(res.begin());

	cout << int(res.size()) << endl;
	for (int i = 0; i < int(res.size()); i++)
		cout << res[i] + 1 << " \n"[i + 1 == int(res.size())];
	cout.flush();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");
	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
