#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

const int N = 300'000;

struct pp {
  int mask, cnt;
  bool win;
};

int n;
string a[N];
int hamming[N][8];
int toCalc[1 << 8][9];
bool dp[N];
vector<int> go[N];

vector<pp> solve(int l, int r) {
  if (l == r) {
    return {pp{0, 1, false}};
  }
  int m = (l + r) / 2;
  auto L = solve(l, m);
  auto R = solve(m + 1, r);

  for (int i = 0; i < 1 << 8; i++) {
    fill(toCalc[i], toCalc[i] + 9, -1);
  }
  for (auto const &t : R) {
    toCalc[t.mask][t.cnt] = 0;
  }

  for (int mask = 0; mask < 1 << 8; mask++) {
    for (int len = 1; len <= 8; len++) {
      if (toCalc[mask][len] == -1) {
        continue;
      }

      fill(dp + l, dp + m + 1, false);

      for (int i = m; i >= l; i--) {
        for (int j : go[i]) {
          if (j <= m) {
            dp[i] |= !dp[j];
          } else if (j - m <= len) {
            dp[i] |= !((mask >> (j - m - 1)) & 1);
          }
        }
      }

      for (int i = 0; i < min(8, m - l + 1); i++) {
        if (dp[i + l]) {
          toCalc[mask][len] |= (1 << i);
        }
      }
    }
  }

  for (auto const &t : R) {
    int newMask = toCalc[t.mask][t.cnt];
    int newCnt = min(8, t.cnt + (m - l + 1));
    if (m - l + 1 < 8) {
      for (int i = 0; i < 8 - (m - l + 1); i++) {
        if (t.mask >> i & 1) {
          newMask |= 1 << (i + m - l + 1);
        }
      }
    }

    L.push_back({newMask, newCnt, (newMask & 1) == 1});
  }

  return L;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  cin >> n;
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    for (int j = max(0, i - 8); j < i; j++) {
      for (int k = 0; k < 8; k++) {
        hamming[j][i - j] += (a[i][k] == a[j][k]);
      }
    }
  }

  for (int i = 0; i < n; i++) {
    for (int j = i + 1; j <= min(n - 1, i + 8); j++) {
      if (j - i <= hamming[i][j - i]) {
        go[i].push_back(j);
      }
    }
  }

  auto res = solve(0, n - 1);
  for (int i = 0; i < n; i++) {
    cout << (res[i].win ? "1" : "2");
  }

  return 0;
}
