#include <algorithm>
#include <bitset>
#include <iostream>
#include <iterator>
#include <random>
#include <set>
#include <vector>

// #define FAST_ALLOCATOR_MEMORY 256000000
// #include "optimization.h"
#include <bits/stdc++.h>

using namespace std;

// #define USE_INT128
// #define int int64_t

// #undef _DEBUG

#define all(x) begin(x), end(x)
#define rall(x) (x).rbegin(), (x).rend()

#ifdef USE_INT128
#define lint __int128
#define ulint __int128
#else
#define lint int64_t
#define ulint int64_t
#endif

typedef long double ld;
// #define f first
// #define s second
typedef pair<int, int> pint;

const int inf = 1 << 30;

template <class T>
T mineq(T& a, const T& b) {
    return a = min(a, b);
}

template <class T>
T maxeq(T& a, const T& b) {
    return a = max(a, b);
}

mt19937 rd(533);
// end of default file

const int w = 8;
const int MASK = (1 << w) - 1;

int32_t main() {
    srand(5332017);
    ios::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    cout << fixed;
    cout.precision(1); // !!

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;

    vector<int> stair(n);
    for (auto& st : stair) {
        string s;
        cin >> s;
        for (auto& c : s) {
            st = (st << 1) + (c == 'R');
        }
    }

    auto canmove = [&stair](int i, int j) {
        int maxd = w - __builtin_popcount(stair[i] ^ stair[j]);
        return maxd >= (j - i);
    };

    vector<bool> win(1 << w);
    for (int i = 1; i < (1 << w); i += 2) {
        win[i] = i & 1;
    }

    vector<bool> ans(min(w, n));
    for (int d = 0; d < ans.size(); d++) {
        bool true_winnable[d+1] = {};
        for (int p = d; p >= 0; p--) {
            for (int to = p + 1; to <= d; to++)
                true_winnable[p] |= !true_winnable[to] && canmove(p, to);
        }
        ans[d] = true_winnable[0];
    }

    for (int i = 1; i + w < n; i++) {
        int l = i;
        int r = i + w;

        vector<int> moves;
        for (int to = 0; to < w; to++) {
            if (canmove(l - 1, l + to))
                moves.push_back(to);
        }

        vector<bool> winn(1 << w);
        for (int mask = 0; mask < 1 << w; mask++) {
            bool winnable = false; // l-1 winnable
            for (int to : moves) {
                if (!(mask & (1 << to))) {
                    winnable = true;
                }
            }
            int old_mask = ((mask << 1) & MASK) + winnable;
            winn[mask] = win[old_mask];
        }
        win = winn;

        bool true_winnable[w] = {};
        for (int p = w - 1; p >= 0; p--) {
            for (int to = p + 1; to < w; to++)
                true_winnable[p] |= !true_winnable[to] && canmove(l + p, l + to);
        }

        int true_mask = 0;
        for (int i = 0; i < w; i++) true_mask |= (true_winnable[i] << i);
        ans.push_back(win[true_mask]);
    }

    for (auto i : ans) cout << 2 - (int)i;
    cout << endl;
}
