﻿#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <iomanip>
#include <array>
#include <numeric>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <queue>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <cassert>

#define all(a) (a).begin(), (a).end()

using namespace std;
using ll = long long;
using ld = long double;

const int N = 70;
const int inf = 1e9 + 228;

int n, m;
int a[N];
int c[N][N];
int d[N][N];

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void gen() {
	n = 5;
	m = 10;
	for (int i = 0; i < m; i++) {
		a[i] = rng() % 10;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			c[i][j] = (i != j) * (i < j ? rng() % 4 : c[j][i]);
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			d[i][j] = (i != j) * (i < j ? rng() % 4 : d[j][i]);
		}
	}
}

void read(istream& cin) {
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> c[i][j];
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> d[i][j];
		}
	}
}

int x[N];

int calc() {
	int ret = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			ret += abs(x[i] - x[j]) * d[i][j];
		}
		for (int j = 0; j < m; j++) {
			ret += abs(x[i] - a[j]) * c[i][j];
		}
	}
	return ret;
}

void solve(ostream& cout) {
	pair<int, vector<vector<int>>> ans = { inf, {} };
	for (int x = 0; x < m; x++) {
		for (int y = 0; y < m; y++) {
			for (int z = 0; z < m; z++) {
				for (int t = 0; t < m; t++) {
					for (int q = 0; q < m; q++) {
						int cur = 0;// calc({ a[x], a[y], a[z], a[t], a[q] });
						if (cur < ans.first) {
							ans = { cur, { { x, y, z, t, q } } };
						}
						else if (cur == ans.first) {
							ans.second.push_back({ x, y, z, t, q });
						}
					}
				}
			}
		}
	}
	cout << ans.first << endl;
	for (auto v : ans.second) {
		for (int x : v) {
			cout << a[x] << ' ';
		}
		cout << endl;
	}
}

int keks[N];

void dummy(ostream& cout) {
	int ans = inf;
	for (int dst = 0; dst < m; dst++) {
		for (int i = 0; i < n; i++) {
			x[i] = a[dst];
		}
		for (int k = 0; k < n; k++) {
			for (int z = 0; z < m; z++) {
				x[k] = a[z];
				int cur = calc();
				if (cur < ans) {
					ans = cur;
					memcpy(keks, x, sizeof(keks));
				}
				x[k] = a[dst];
			}
		}
	}
	cout << ans << endl;
	for (auto i = 0; i < n; i++) {
		cout << keks[i] << ' ';
	}
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int tc = 1;
	// cin >> tc;
	while (tc--) {
		read(cin);
		//gen();
		//solve(cout);
		dummy(cout);
	}
}
