﻿// Author: Igor Smirnov
#ifdef DEBUG_MODE
#define _GLIBCXX_DEBUG 1
#endif
#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef unsigned int ui;
typedef unsigned long long ull;

#define vin(n) vector<int>(n, 0)
#define vvin(n, m) vector<vector<int>>(n, vector<int>(m, 0))
#ifndef CERR_ON
#define cerr if (false) cerr
#endif
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rev(a) reverse(all(a))
#define csp(a) cout << a << ' '
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define next next42

inline void init() {
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
}

int n;
const int MAXN = 200001;

int l[MAXN];
int r[MAXN];
int k[MAXN];
int mn[MAXN];
int mx[MAXN];

void fix_tree(int node) {
    if (l[node] != -1) {
        fix_tree(l[node]);
    }
    if (r[node] != -1) {
        fix_tree(r[node]);
    }

    mn[node] = l[node] != -1 ? mn[l[node]] : k[node];
    mx[node] = r[node] != -1 ? mx[r[node]] : k[node];
}

vector<pii> plus_prefix;
vector<pii> plus_suffix;
vector<pii> prs;
vector<pii> ss;
vector<pii> plus_square;

void calculate(int v, pii p) {
    if (v != -1) {
        calculate(l[v], {mn[v], mx[v]});
        calculate(r[v], {mn[v], mx[v]});
    }
    auto [l, r] = p;
    plus_prefix.emplace_back(r, -1);
    plus_prefix.emplace_back(l, 1);
    plus_suffix.emplace_back(r + 1, -1);
    plus_suffix.emplace_back(l + 1, 1);
    plus_square.emplace_back(l, r);
}

struct Event {
    int x;
    int type; // -2 -- закрытие запроса -1 закрытие вершины -3 открытие вершины
    int queryId;
    int left;

    bool operator<(const Event& other) const {
        if (x != other.x) {
            return x < other.x;
        }
        return type < other.type;
    }
};


#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<
        pii,
        null_type,
        less<pii>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

int main() {
    init();
    cout.precision(20);
    cin >> n;

    for (int i = 0; i < n; i++) {
        int l1, r1, k1;
        cin >> l1 >> r1 >> k1;
        l[i] = l1 - 1;
        r[i] = r1 - 1;
        k[i] = k1;
    }
    fix_tree(0);
    int q;
    cin >> q;
    const int INF = 1e9 + 42;
    calculate(0, {-INF, INF});
    sort(all(plus_prefix));
    sort(all(plus_suffix));
    assert(plus_suffix.size() == plus_prefix.size());
    forn(i, plus_prefix.size()) {
        if (i == 0) {
            prs.push_back(plus_prefix[i]);
            ss.push_back(plus_suffix[i]);
        }
        else {
            prs.emplace_back(plus_prefix[i].first, plus_prefix[i].second + prs.back().second);
            ss.emplace_back(plus_suffix[i].first,ss.back().second + plus_suffix[i].second);
        }
    }
    vector<int> ans(q);
    vector<Event> events;
    int xxx = 0;
    for (auto [l, r]: plus_square) {
        events.push_back(Event{l, -3, xxx, -1});
        events.push_back(Event{r, -1, xxx, l});
        ++xxx;
    }
    for (int i = 0; i < q; ++i) {
        int left, right;
        cin >> left >> right;
        int ip = lower_bound(prs.begin(), prs.end(), make_pair(right + 1, INT_MIN)) - prs.begin();
        --ip;
        if (ip >= 0) {
            ans[i] += prs[ip].second;
            //cerr << "ADD_PREFIX " << prs[ip].second << endl;
        }
        int is = lower_bound(ss.begin(), ss.end(), make_pair(left + 1, INT_MIN)) - ss.begin();
        --is;
        if (is >= 0) {
            ans[i] += ss[is].second;
        }
        events.push_back(Event{right, -2, i, left});
        //cerr << ans[i] << ' ' << is << ' ' << ip << endl;
    }
    sort(all(events));
    ordered_set ee;
    for (auto event: events) {
        if (event.type == -3) {
            ee.insert({event.x, event.queryId});
        }
        if (event.type == -2) {
            ans[event.queryId] -= ee.order_of_key({event.left, INT_MAX});
        }
        if (event.type == -1) {
            ee.erase({event.left, event.queryId});
        }
    }
    for (auto u : ans) {
        cout << u << '\n';
    }

}