#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>

using namespace std;
// using namespace __gnu_pbds;

//-----------------------------------------------
// #define LOG
#ifdef LOG
  #define db(x)     cerr << #x << ": " << x << endl;
  #define dbA(x, s) cerr << #x << ": "; for (int i = 0; i < s; i++) cerr << x[i] << " "; cerr << endl;
#else
  #define db(x)
  #define dbA(x, s)
#endif
//-----------------------------------------------
template<class K, class V> ostream& operator << (ostream& out, const pair<K, V>& obj) { out << "{ " << obj.first << ", " << obj.second << " }"; return out; }
template<class T> ostream& operator << (ostream& out, const vector<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const deque<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const unordered_set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const unordered_map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
//-----------------------------------------------
#define all(x)  x.begin(), x.end()
#define sz(x)   (int)x.size()
#define sq(x)   (x) * (x)
#define fr      first
#define sc      second
//-----------------------------------------------
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<ll, int>;
//-----------------------------------------------
const int N   = 1000 * 1000 + 5;
const ll mod  = 1000000007;
const ll mod3 = 998244353;
const ll INFL = 1000000000 * 1ll * 1000000000 + 500000;
const ll INF  = 1000000000;
const ld pi   = acosl(-1.0);
//-----------------------------------------------

int a, b;

void input() {
  cin >> a >> b;
}

int vals[N];

vector<int> gen_fft_arr(int n) {
  vector<int> inds(n, 0);
  for (int i = 0; i < n; i++) {
    inds[i] = i;
  }

  for (int i = 0; i < n; i++) {
    int rev = 0;
    for (int j = 1, bit = (n >> 1); j < n; j <<= 1, bit >>= 1) {
      if (i & j) {
        rev |= bit;
      }
    }
    if (i < rev) {
      swap(inds[i], inds[rev]);
    }
  }
  return inds;
}

void check_validity() {
  int n = 1;
  while (b > n - 1) {
    n <<= 1;
  }
  if (a + b < n - 1) {
    cout << -1 << endl;
    exit(0);
  }
}

void solve(int test_id) {
  // auto a = gen_fft_arr(8);
  // db(a);
  // return;
  if (a == 0 && b == 1 || a == 1 && b == 0) {
    cout << (a == 0 ? 2 : 1) << " " << 0 << " " << 0 << endl;
    return;
  }
  check_validity();
  int n = 1;
  
  while (n - 1 <= b) {
    n <<= 1;
  }
  int overall = a + b;
  int start = n / 2;

  for (int i = 1; i < start; i++) {
    vals[i] = 2;
  }

  auto ord = gen_fft_arr(n / 2);
  for (int& elem : ord) {
    elem += start;
  }

  vector<int> new_ord;
  if (b + 1 != n / 2) {
    for (int i = b - start + 1; i < n / 2; i++) {
      vals[ord[i]] = 1;
      new_ord.push_back(ord[i]);
      a--;
    }

    dbA(vals, 20);
    for (int i = 0; i <= b - start; i++) {
      vals[ord[i]] = 2;
      new_ord.push_back(ord[i]);
    }
  } else {
    n /= 2;
    start /= 2;
    db(n);
    db(start);
    if (n == 1) {
      vals[1] = 1;
      n = 2;
      start = 1;
      a--;
    }
    new_ord = gen_fft_arr(n / 2);
    for (int& elem : new_ord) {
      elem += start;
    }
  }
  db(new_ord);

  int pw = 2;
  while (a) {
    auto tmp = gen_fft_arr(pw);
    for (int i = 0; i < pw; i++) {
      for (int offs : new_ord) {
        vals[offs * pw + tmp[i]] = 1;
        a--;
        if (!a) break;
      }
      if (!a) break;
    }
    pw <<= 1;
  }

  map<int, int> mapper;
  for (int i = 1; i < N; i++) {
    if (vals[i]) {
      mapper[i] = mapper.size() + 1;
    }
  }
  for (int i = 1; i <= N; i++) {
    if (vals[i])
      cout << vals[i] << " " << (vals[2 * i] ? mapper[2 * i] : 0) << " " << (vals[2 * i + 1] ? mapper[2 * i + 1] : 0) << endl;
  }
}

int main() {
  // precalc();
  // return 0;
  int testcases = 1;
  // scanf("%d", &testcases);
  for(int test_id = 1; test_id <= testcases; test_id++) {
    input();
    solve(test_id);
  }
  return 0;
}
