#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <algorithm>
#include <math.h>
#include <map>

using namespace std;

map <int, int> mp;
int l[200002], r[200002], k[200002], mx[200002], mn[200002];
pair <int, int> q[200002];
pair <int, int> mij[200002];
pair<int, pair<int,pair<int, int> > > obshi[400002];
int ans[200002];
vector<int> tver;

int tr[(1 << 22) + 50];

void build(int v, int l, int r) {
  tr[v] = 0;
  if (l == r - 1) return;
  int m = (l + r) / 2;
  build(v * 2, l, m);
  build(v * 2 + 1, m, r);
  tr[v] = 0;
}

void update(int v, int l, int r, int pos) {
  tr[v]++;
  if (l == r - 1) return;
  int m = (l + r) / 2;
  if (pos < m)  update(v * 2, l, m, pos); 
  if (pos >= m) update(v * 2 + 1, m, r, pos); 
}


int query(int v, int l, int r, int ql, int qr) {
  if (ql <= l && r <= qr) return tr[v];
  if (qr <= l || r <= ql) return 0;
  int m = (l + r) / 2;
  return query(v * 2, l, m, ql, qr) + query(v * 2 + 1, m, r, ql, qr);
}

void dfs(int gag) {
  mn[gag] = k[gag];
  mx[gag] = k[gag];
  if (l[gag] != 0) {
    dfs(l[gag]);
    mn[gag] = min(mn[gag], mn[l[gag]]);
    mx[gag] = max(mx[gag], mx[l[gag]]);
  }
  if (r[gag] != 0) {
    dfs(r[gag]);
    mn[gag] = min(mn[gag], mn[r[gag]]);
    mx[gag] = max(mx[gag], mx[r[gag]]);
  }
}

int main() {
  int n;
  cin >> n;
  for (int i = 1; i <= n; i++) {
    cin >> l[i] >> r[i] >> k[i];
    tver.push_back(k[i]);
  }
  int Q;
  cin >> Q;
  for (int i = 0; i < Q; i++) {
    ans[i] = 1;
    cin >> q[i].first >> q[i].second;
    tver.push_back(q[i].first);
    tver.push_back(q[i].second);
  }
  sort(tver.begin(), tver.end());
  int cntr = 0;
  for (int i = 0; i < tver.size(); i++) {
    if (i == 0 || tver[i] != tver[i - 1]) {
      mp[tver[i]] = cntr++;
    }
  }
  for (int i = 1; i <= n; i++) {
    k[i] = mp[k[i]];
  }
  for (int i = 0; i < Q; i++) {
    q[i].first = mp[q[i].first];
    q[i].second = mp[q[i].second];
  }

  dfs(1);
  for (int i = i; i <= n; i++) {
    mij[i - 1].first = mn[i];
    mij[i - 1].second = mx[i];
  }
  // sort(q, q + Q);
  // sort(mij, mij + n);
  for (int i = 0; i < n; i++) {
    obshi[i] = make_pair(mij[i].first, make_pair(1, make_pair(mij[i].second, -1)));
  }
  for (int i = 0; i < Q; i++) {
    obshi[n + i] = make_pair(q[i].first, make_pair(0, make_pair(q[i].second, i)));
  }
  sort(obshi, obshi + n + Q);
  build(1, 0, cntr + 3);
  for (int i = 0; i < n + Q; i++) {
    if (obshi[i].second.first == 0) {
      ans[obshi[i].second.second.second] += 2 * query(1, 0, cntr + 3, obshi[i].first, cntr);
    } else {
      update(1, 0, cntr + 3, obshi[i].second.second.first);
    }
  }

  for (int i = 0; i < n; i++) {
    obshi[i] = make_pair(-mij[i].second, make_pair(1, make_pair(mij[i].first, -1)));
  }
  for (int i = 0; i < Q; i++) {
    obshi[n + i] = make_pair(-q[i].second, make_pair(0, make_pair(q[i].first, i)));
  }
  sort(obshi, obshi + n + Q);
  build(1, 0, cntr + 3);
  
  for (int i = 0; i < n + Q; i++) {
    if (obshi[i].second.first == 0) {
      ans[obshi[i].second.second.second] += 2 * query(1, 0, cntr + 3, obshi[i].second.second.first, -obshi[i].first);
    } else {
      update(1, 0, cntr + 3, obshi[i].second.second.first);
    }
  }

  for (int i = 0; i < Q; i++) {
    cout << ans[i] << endl;
  }
  return 0;
}
