#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <complex>
#include <bitset>
#include <vector>
#include <cstdio>
#include <random>
#include <chrono>
#include <queue>
#include <cmath>
#include <list>
#include <set>
#include <map>
using namespace std;
using namespace __gnu_pbds;
typedef pair<int, int> pii;
typedef pair<int, pii> pip;
typedef pair<long long, int> pli;
typedef pair<long long, long long> pll;
typedef pair<long double, long double> pdd;
typedef tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update> oset;
typedef complex<double> base;
const int N = 1000010;
const int mod = 1000000007;
const long double eps = 1e-9;
mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());


int f[N];
int invf[N];

int c(int x, int y) {
    if (x < 0) return 0;
    if (y < 0) return 0;
    if (x < y) return 0;
    return f[x] * 1ll * invf[y] % mod * 1ll * invf[x - y] % mod;
}

struct point {
    double x, y;
    point() {}
    point(double x, double y): x(x), y(y) {}
    point operator-(const point &b) {
        return point(x - b.x, y - b.y);
    }
    double cross(const point &b) {
        return x * b.y - y * b.x;
    }
};

int gety(point a, point b, int x) {
    double c = (b.y - a.y) * (x - a.x) / (b.x - a.x) + a.y;
    if (c < -1e-9) return -1;
    return int(c + 1e-9);
}

int cnt(point a, point b, bool inc) {
    int res = 0;
    for (int i = int(a.x + 0.7); i < b.x + 0.2; ++i) {
        int y = gety(a, b, i);
        res += c(i + y + 1, i + 1);
    }
    if (inc) {
        if (a.x > -0.2 && a.y > -0.2)
            res -= c(int(a.y + 0.2) + int(a.x + 0.2) + 1, int(a.x + 0.2) + 1);
        if (b.x > -0.2 && a.y > -0.2)
            res -= c(int(b.y + 0.2) + int(b.x + 0.2) + 1, int(b.x + 0.2) + 1);
    }
    return res;
}

void solve() {
    f[0] = 1;
    for (int i = 1; i <= 1e6; ++i) f[i] = f[i - 1] * 1ll * i % mod;
    invf[0] = invf[1] = 1;
    for (int i = 2; i <= 1e6; ++i) invf[i] = (mod - invf[mod % i] * 1ll * (mod / i) % mod) % mod;
    for (int i = 2; i <= 1e6; ++i) invf[i] = invf[i] * 1ll * invf[i - 1] % mod;

    int t;
    scanf("%d", &t);
    for (int i = 0; i < t; ++i) {
        int xa, ya, xb, yb, xc, yc;
        scanf("%d%d%d%d%d%d", &xa, &ya, &xb, &yb, &xc, &yc);
        point a((xa + ya) / 2.0, (ya - xa) / 2.0);
        point b((xb + yb) / 2.0, (yb - xb) / 2.0);
        point c((xc + yc) / 2.0, (yc - xc) / 2.0);
        if (b.x < a.x && b.x < c.x) swap(a, b);
        if (c.x < a.x && c.x < b.x) swap(a, c);

        if (b.x > a.x && b.x > c.x) swap(c, b);
        if (a.x > c.x && a.x > b.x) swap(a, c);
        if (abs(a.x - b.x) < 0.2) {
            if (a.y < b.y) swap(a, b);
            printf("%d\n", cnt(a, c, 0) - cnt(b, c, 1));
        } else if (abs(b.x - c.x) < 0.2) {
            if (b.y < c.y) swap(b, c);
            printf("%d\n", cnt(a, b, 0) - cnt(a, c, 1));
        } else {
            if ((b - a).cross(c - a) > 0) {
                printf("%d\n", abs(cnt(a, c, 0) - cnt(b, c, 1) - cnt(a, b, 1)));
            } else {
                printf("%d\n", abs(cnt(a, b, 0) + cnt(b, c, 0) - cnt(a, c, 1) - 1));
            }
        }
    }
}


int main() {
#ifdef HAMLET
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
