///////////////////////////////     _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 200005;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());

int n, q;
pair <int, int> seg[N];

int k[N];
vector <int> g[N];
int answ[N];

void dfs(int v) {
    seg[v].first = seg[v].second = k[v];
    for (int i = 0; i < (int)g[v].size(); i++) {
        int to = g[v][i];
        dfs(to);
        seg[v].first = min(seg[v].first, seg[to].first);
        seg[v].second = max(seg[v].second, seg[to].second);
    }
}

int l[N], r[N];
vector <int> X;

int t[N * 80], timer;
int son1[N * 80], son2[N * 80];
int root[N * 4];

void build(int v, int s, int e) {
    if (s == e) return ;
    int m = (s + e) / 2;
    if (son1[v] == 0) {
        son1[v] = ++timer;
        son2[v] = ++timer;
    }
    build(son1[v], s, m);
    build(son2[v], m + 1, e);
}

int update(int v, int s, int e, int pos) {
    int nv = ++timer;
    if (s == e) {
        t[nv] = t[v] + 1;
        return nv;
    }
    int m = (s + e) / 2;
    if (pos <= m) {
        son2[nv] = son2[v];
        son1[nv] = update(son1[v], s, m, pos);
    } else {
        son1[nv] = son1[v];
        son2[nv] = update(son2[v], m + 1, e, pos);
    }
    t[nv] = t[ son1[nv] ] + t[ son2[nv] ];
    return nv;
}

int get(int v, int s, int e, int l, int r) {
    if (l > r) return 0;
    if (s == l && e == r) return t[v];
    int m = (s + e) / 2;
    return get(son1[v], s, m, l, min(r, m)) + get(son2[v], m + 1, e, max(m + 1, l), r);
}

int main() {
    scanf("%d", &n);

    for (int i = 1; i <= n; i++) {
        int a, b;
        scanf("%d%d%d", &a, &b, &k[i]);
        if (a != 0) {
            g[i].push_back(a);
        }
        if (b != 0) {
            g[i].push_back(b);
        }
    }

    dfs(1);

    for (int i = 1; i <= n; i++) {
        X.push_back(seg[i].first);
        X.push_back(seg[i].second);
    }

    scanf("%d", &q);
    for (int i = 1; i <= q; i++) {
        scanf("%d%d", &l[i], &r[i]);
        X.push_back(l[i]);
        X.push_back(r[i]);
    }

    sort(X.begin(), X.end());
    X.resize( unique(X.begin(), X.end()) - X.begin() );

    vector <int> R, L;
    for (int i = 1; i <= n; i++) {
        seg[i].first = X[ lower_bound(X.begin(), X.end(), seg[i].first) - X.begin() ];
        seg[i].second = X[ lower_bound(X.begin(), X.end(), seg[i].second) - X.begin() ];
        ///
        R.push_back(seg[i].second);
        L.push_back(seg[i].first);
    }

    sort(L.begin(), L.end());
    sort(R.begin(), R.end());

    sort(seg + 1, seg + n + 1);

    for (int i = 1; i <= q; i++) {
        l[i] = X[ lower_bound(X.begin(), X.end(), l[i]) - X.begin() ];
        r[i] = X[ lower_bound(X.begin(), X.end(), r[i]) - X.begin() ];
        ///
        int ind = upper_bound(R.begin(), R.end(), l[i] - 1) - R.begin() - 1;
        answ[i] += ind + 1;
        ind = upper_bound(L.begin(), L.end(), r[i]) - L.begin();
        answ[i] += (int)L.size() - ind;
    }

    build(1, 0, (int)X.size() - 1);
    root[(int)X.size()] = 1;

    int it = n;
    for (int i = (int)X.size() - 1; i >= 0; i--) {
        root[i] = root[i + 1];

        while (it >= 1 && seg[it].first == X[i]) {
            int pos = lower_bound(X.begin(), X.end(), seg[it].second) - X.begin();
            root[i] = update(root[i], 0, (int)X.size() - 1, pos);
            --it;
        }
    }

    for (int i = 1; i <= q; i++) {
        int L = lower_bound(X.begin(), X.end(), l[i]) - X.begin();
        int R = lower_bound(X.begin(), X.end(), r[i]) - X.begin();
        answ[i] += get(root[L], 0, (int)X.size() - 1, L, R);
        answ[i] = n - answ[i];
        printf("%d\n", 2 * answ[i] + 1);
    }
    return 0;
}
