#include <iostream>
#include <vector>
#include <array>
#include <cmath>


int main()
{
    int n;
    std::cin >> n;
    std::vector<std::array<char, 8>> info(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 8; ++j) {
            std::cin >> info[i][j];
        }
    }

    std::vector<std::vector<int>> can_step(n);

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < std::min(i + 9, n); ++j) {
            char sim = 0;
            for (int k = 0; k < 8; ++k) {
                if (info[i][k] == info[j][k]) {
                    ++sim;
                }
            }
            if (sim >= j - i) {
                can_step[i].push_back(j);
            }
        }
    }

    std::vector<char> states(n);
    for (int d = 0; d < n; ++d) {
        int dist = 0;
        states[d] = 0;
        for (int k = d - 1; k >= 0; --k) {
            auto& steps = can_step[k];
            char ini_state = states[k];
            states[k] = 0;
            for (int c = 0; c < steps.size(); ++c) {
                if (steps[c] <= d && states[steps[c]] == 0) {
                    states[k] = 1;
                    if (ini_state == 1) {
                        ++dist;
                    } else {
                        dist = 0;
                    }
                    break;
                }
            }
            if (ini_state == states[k]) {
                ++dist;
            } else {
                dist = 0;
            }
            if (dist > 8) {
                break;
            }
        }
        std::cout << ((states[0] == 0) ? 2 : 1);
    }
    std::cout << std::endl; 
    return 0;
}
