#include <iostream>
#include <string>
#include <queue>
#include <cmath>
#include <algorithm>
#include <stack>
#include <deque>
#include <iomanip>
#include <cstring>
#include <vector>
#include <cstdlib>
 
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

int n, m, a[100002], b[100002], c[100002];

template <class T>
struct nodeTree {
    nodeTree* left;
    nodeTree* right;
    int key;
    T value;
    nodeTree(T v, int k, nodeTree* l = NULL, nodeTree* r = NULL) {
        value = v;
        key = k;
        left = l;
        right = r;
    }
};

template <class T>
class binSTree {
    nodeTree<T>* first;

    int sum(nodeTree<T>* q) {
        if(!q)
            return 0;
        
        return q->key + sum(q->left) + sum(q->right);
    }

public:
    binSTree() {
        first = NULL;
    }

    void insert(nodeTree<T>* q) {
        nodeTree<T>* u = q;
        if(empty()) {
            first = u;
            return;
        }
        nodeTree<T>* g = first;
        while(true) {
            if(!g->right) {
                g->right = q;
                break;
            }
            else if(!g->left) {
                g->left = q;
                break;
            }
            else { 
                if(sum(g->right) <= sum(g->left)) {
                    g = g->right;
                }
                else {
                    g = g->left;
                }
            }
            
        }
    }

    bool empty() const {
        if(first)
            return false;
        return true;
    }

    void preorder() {
        preorder_p(first);
    }

    void preorder_p(nodeTree<T>* q) {
        if(!q)
            return;
        a[q->value] = q->key;
        if(q->left)
            b[q->value] = (q->left)->value;
        else
        {
            b[q->value] = 0;
        }
        if(q->right)
            c[q->value] = (q->right)->value;
        else
        {
            c[q->value] = 0;
        }

        preorder_p(q->left);
        preorder_p(q->right);
    }
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    binSTree<int> z;
    if(n == 0 && m%2 == 0)
        cout<<"-1"<<endl;
    else {
        for(int i = 0;i < n + m; ++i) {
            int x;
            if(i < m) {
                x = 2;
            }
            else {
                x = 1;
            }
            nodeTree<int>* q = new nodeTree<int>(i + 1, x);
            z.insert(q);
        }
        z.preorder();
        for(int i = 1;i <= n + m; ++i) {
            cout<<a[i]<<" "<<b[i]<<" "<<c[i]<<endl;
        }
    }
	return 0;
}