﻿#include <iostream>
#include <string>
#include <cmath>
#include <vector>
#include <numeric>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<ll, ll> pii;

vector<int> v;


bool inRange(int val, int l, int r)
{
	return val >= l && val < r;
}

void leftInsert(int val, int& count, int levelSize, int startInd, bool rtol = false)
{
	int endInd = startInd + levelSize;

	int first = startInd, second = startInd + levelSize / 2;
	int step = 2 - 4 * rtol;

	if (rtol)
		swap(first, second);

	while (count && inRange(first, 0, endInd) && inRange(second, 0, endInd))
	{
		if (count)
		{
			v[first] = val;
			--count;
		}

		if (count)
		{
			v[second] = val;
			--count;
		}

		first += step;
		second += step;
	}

}

void rightInsert(int val, int& count, int levelSize, int startInd, bool rtol = false)
{	
	int endInd = startInd + levelSize;
	
	int first = startInd + levelSize / 2 - 1, second = endInd - 1;
	int step = 2 - 4 * rtol;

	if (rtol)
		swap(first, second);

	while (count && inRange(first, 0, endInd) && inRange(second, 0, endInd))
	{
		if (count)
		{
			v[first] = val;
			--count;
		}

		if (count)
		{
			v[second] = val;
			--count;
		}

		first += step;
		second += step;
	}
}


void insert(int val, int& count, int levelSize, int startInd, bool rtol = false)
{
	if (rtol)
	{
		rightInsert(val, count, levelSize, startInd, rtol);
		leftInsert(val,count, levelSize, startInd, rtol);
	}
	else
	{
		leftInsert(val, count, levelSize, startInd, rtol);
		rightInsert(val, count, levelSize, startInd, rtol);
	}
	
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int a, b;
	cin >> a >> b;

	int total = a + b;

	int size = 1;

	while (size <= a + b)
		size *= 2;

	++size;
	v.resize(size);

	int pow = 1, ind = 0;

	while (b >= pow)
	{
		for (int i = ind; i < ind + pow; ++i)
		{
			v[i] = 2;
			--b;
		}
		ind = ind + pow;
		pow *= 2;
	}

	if (b + a < pow)
	{
		cout << -1 << endl;
		return 0;
	}

	while (b)
		insert(2, b, pow, ind);

	for (int i = ind; i < ind + pow; ++i)
	{
		if (v[i] == 0)
		{
			++v[i];
			--a;
		}
	}

	ind += pow;
	pow *= 2;
	while (a)
	{
		insert(1, a, pow, ind, true);
		ind += pow;
		pow *= 2;
	}

	int child = 1;
	for (int i = 0; total; ++i)
	{
		if (v[i])
		{
			cout << v[i] << " ";
			if (inRange(2 * i + 1, 0, v.size()) && v[2 * i + 1])
				cout << ++child << " ";
			else
				cout << "0 ";
			if (inRange(2 * i + 2, 0, v.size()) && v[2 * i + 2])
				cout << ++child << " ";
			else
				cout << "0 ";

			cout << endl;
			--total;
		}
	}
	
}