#include <vector>
#include <iostream>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <iomanip>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;


ll C(ll n, ll k)
{
	if (k > n) return 0;
	if (k * 2 > n) k = n - k;
	if (k == 0) return 1;

	ll result = n;
	for (ll i = 2; i <= k; ++i) {
		result *= (n - i + 1);
		result /= i;
	}
	return result;
}

int main()
{
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;
	multimap<int, pair<int, string>> prices;
	for (int i = 0; i < n; ++i)
	{
		int p;
		cin >> p;
		string s;
		cin >> s;
		prices.insert(make_pair(p, make_pair(i, s)));
	}

	for (auto it = prices.begin(); it != prices.end(); ++it)
	{
		int sum = 0;
		vector<int> vec(4);
		string s = it->second.second;
		int price = it->first;
		for (int i = 0; i < s.size(); ++i)
		{
			if (s[i] == '0' || s[i] == '2' || s[i] == '1')
			{
				if (s[i] == '2' && vec[2] < 2)
				{
					sum += price;
					vec[2]++;
				}
				if (s[i] == '1' && vec[1] < 1)
				{
					sum += price;
					vec[1]++;
				}
				if (s[i] == '0' && vec[0] < 1)
				{
					sum += price;
					vec[0]++;
				}
			}
		}

		if (vec[0] == 1 && vec[1] == 1 && vec[2] == 2)
		{
			cout << it->second.first + 1 << endl;
			return 0;
		}
	}
	cout << 0 << endl;
}


/*

4
150 9876543210
150 012345678924568
140 00112233445566778899
150 000000123456789


*/