#include <cstring>
#include <iostream>
#include <vector>
#include <algorithm>

std::vector<int> visitors[100005];
std::vector<int> visited_on[100005];

std::vector<int> g[100005];
std::vector<int> gr[100005];
int used[100005];
std::vector<int> order;
int d[100005];

void dfs(int v) {
    used[v] = 1;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (!used[to]) {
            dfs(to);
        }
    }
    order.push_back(v);
}

int main() {
    int n;
    std::cin >> n;

    std::vector<int> people_ids;
    for (int i = 0; i < n; ++i) {
        int cnt;
        std::cin >> cnt;
        for (int j = 0; j < cnt; ++j) {
            int x;
            std::cin >> x;
            visitors[i].push_back(x);
            visited_on[x].push_back(i);
        }
    }

    for (int i = 1; i <= 100000; ++i) {
        for (int j = 1; j < visited_on[i].size(); ++j) {
            auto u = visited_on[i][j - 1];
            auto v = visited_on[i][j];
            g[u].push_back(v);
            gr[v].push_back(u);
        }
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }

    std::reverse(order.begin(), order.end());

    int ans = 0;
    for (int i = 0; i < order.size(); ++i) {
        int maxval = 0;
        int v = order[i];
//        std::cout << v << std::endl;
        for (auto& incoming : gr[v]) {
//            std::cout << "incoming edge: " << incoming << " " << v << std::endl;
            if (d[incoming] > maxval) {
                maxval = d[incoming];
            }
        }
        d[v] = maxval + 1;
        ans = std::max(d[v], ans);
    }

    std::cout << ans;

    return 0;
}

/*

5
1 1
2 1 2
1 2
1 2
1 1

 */