import java.util.Scanner;

public class A {
    static class Node{
        public Node left, right;
        public int weight, index, weightSubtree;

        public Node(Node left, Node right, int weight){
            this.left = left;
            this.right = right;
            this.weight = weight;

            this.weightSubtree = weight;
            if(this.left != null)
                this.weightSubtree += this.left.weightSubtree;
            if(this.right != null)
                this.weightSubtree += this.right.weightSubtree;
        }

        public int distributeIndices(int index){
            if(Math.abs(this.balance()) >= 2){
                System.out.println(-1);
                System.exit(0);
            }
            this.index = index;
            if(this.left != null)
                index = this.left.distributeIndices(index + 1);
            if(this.right != null)
                index = this.right.distributeIndices(index + 1);
            return index;
        }

        public int balance(){
            return (left == null ? 0:left.weightSubtree) - (right == null ? 0:right.weightSubtree);
        }

        public void printTree(){
            System.out.print(this.weight + " ");
            System.out.print((this.left == null ? 0:this.left.index) + " ");
            System.out.print((this.right == null ? 0:this.right.index) + " \n");
            if(this.left != null)
                this.left.printTree();
            if(this.right != null)
                this.right.printTree();
        }

        public void insert(int weight) {
            this.weightSubtree += weight;
            if(this.balance() > 0){
                if(this.right == null)
                    this.right = new Node(null, null, weight);
                else
                    this.right.insert(weight);
            }
            else{
                if(this.left == null)
                    this.left = new Node(null, null, weight);
                else
                    this.left.insert(weight);
            }
        }
    }
    static class Tree{
        Node root;

        public Tree(Node root){
            this.root = root;
        }

        public void insert(int weight){
            if(root == null){
                this.root = new Node(null, null, weight);
            }
            else{
                this.root.insert(weight);
            }
        }
    }
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int A = sc.nextInt();
        int B = sc.nextInt();
        if(A == 0 && B % 2 == 0){
            System.out.println(-1);
        }
        else{
            Tree tr = new Tree(null);
            for (int i = 0; i < B; i++) {
                tr.insert(2);
            }
            for (int i = 0; i < A; i++) {
                tr.insert(1);
            }
            tr.root.distributeIndices(1);
            tr.root.printTree();
        }
    }
}
