//#include <bits/stdc++.h>
#include <algorithm>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

// __________________________________  Defines  ________________________________________ \\

#define Sort(v)				sort(v.begin(), v.end())
#define Is_Sorted(v)		is_sorted(v.begin(), v.end())
#define Reverse(V)			reverse(V.begin(), V.end())
#define Scan_Vector(V)		for(auto &elem : V) cin >> elem;
#define Print_Vector(V)		for(auto &elem : V) cout << elem << " "; cout << endl;
#define Println_Vector(V)	for(auto &elem : V) cout << elem << endl;
#define Print_Matrix(M)		for(auto &V : M) { for(auto &elem : V) cout << elem << " "; cout << endl; }
#define Print_YES_NO(b)		if(b) cout << "YES" << endl; else cout << "NO" << endl;
#define Map(V, R, fn)		std::transform(V.begin(), V.end(), back_inserter(R), fn);
#define For(i, n)			for(int i = 0; i < n; i+=1)
#define Rof(i, n)			for(int i = n-1; i >= 0; i-=1)

#define PI 3.141592653589793238462643383279502884197169399375105820974944592307816406286
#define LL long long
#define MOD 1e9 + 7;

// __________________________________  Template Method Prototypes  _____________________________________ \\

template <typename T> T Sum_Of_Digits(T n);
template <typename T> T Vector_Sum(vector<T> &V);
template <typename T> T Vector_Max(vector<T> &V);
template <typename T> T Vector_Min(vector<T> &V);
template <typename T> T Vector_Min_Index(vector<T> &V);
template <typename T> T Vector_Max_Index(vector<T> &V);
template <typename T> bool Vector_Is_Sorted(vector<T> &V);
template <typename T> bool Vector_All_Elements_Are_Equal(vector<T> &v);
template <typename T> vector<T> Get_Divisors(T n);
template <typename T> bool Is_Prime(T n);
template <typename T> bool Is_Perfect_Number(T n);
template <typename T> T Next_Prime_Divisor_From(T n, T from);
template <typename T> T GCD(T a, T b);
template <typename T> void Build_Eratosthenes_Sieve(vector<T> &d, vector<T> &f, T n);

// _________________________________________ solve _____________________________________________ //

bool DFS(vector< vector<int> > &v, int &index, int A, int B)
{
	if(A == 0 and B == 0) return true;

	v[index][1] = 0;
	v[index][2] = 0;

	int savedIndex = index;
	index++;
	bool flag = true;

	if(A == 1 and B % 2 == 0) {
		v[savedIndex][0] = 1;
		A--;
		if(B != 0) {
			v[savedIndex][1] = index;
			flag = flag and DFS(v, index, 0, B/2);
			v[savedIndex][2] = index;
			flag = flag and DFS(v, index, 0, B/2);
			return flag;
		}
	}

	if(B > 0) {
		v[savedIndex][0] = 2;
		B--;

		if(A == 0 and B == 0) return true;

		v[savedIndex][1] = index;

		if(A % 2 == 0 and B % 2 == 0) {
			flag = DFS(v, index, A/2, B/2);
			v[savedIndex][2] = index;
			flag = flag and DFS(v, index, A/2, B/2);
		} else if(A % 2 == 0) {

			if(A == 0) return false;
			flag = DFS(v, index, A/2-1, B/2+1);
			v[savedIndex][2] = index;
			flag = flag and DFS(v, index, A/2+1, B/2);

		} else if(B % 2 == 0) {
			flag = DFS(v, index, A/2+1, B/2);
			if(A == 1 and B == 0) return flag;
			v[savedIndex][2] = index;
			flag = flag and DFS(v, index, A/2, B/2);
		} else {
			flag = DFS(v, index, A/2, B/2+1);
			v[savedIndex][2] = index;
			flag = flag and DFS(v, index, A/2+1, B/2);
		}
	} else if(A > 0){ /// A > 0
		v[savedIndex][0] = 1;
		A--;

		if(A == 0 and B == 0) return true;
		v[savedIndex][1] = index;
		flag = flag and DFS(v, index, A/2+A%2, 0);
		if(A == 1) return flag;
		v[savedIndex][2] = index;
		flag = flag and DFS(v, index, A/2, 0);
	}

	return flag;
}


void solve()
{
	int A, B; cin >> A >> B;
	vector< vector<int> > v(A+B+1, vector<int>(3, -1));
	int index = 1;
	bool flag = DFS(v, index, A, B);
	if(!flag)
		cout << -1 << endl;
	else {
		for(int i = 1; i < v.size(); i++){
			auto _v = v[i];
			Print_Vector(_v);
		}
	}
}


// _________________________________________ main _____________________________________________ \\

int main()
{
	int numTests = 1;
//	cin >> numTests;

	For(iTest, numTests)
	{
		solve();
	}
}






















// ____________________________________ TEMPLATE FUNCTIONS ________________________________ \\


template <typename T>
T Sum_Of_Digits(T n)
{
	T sum=0;
	while(n) {
		sum += n%10;
		n/=10;
	}
	return sum;
}

template <typename T>
T Vector_Sum(vector<T> &V)
{
	T sum = 0;
	for(T t : V)
		sum += t;
	return sum;
}

template <typename T>
T Vector_Max(vector<T> &V)
{
	T mx = V[0];
	for(T t : V)
		if(t > mx) mx = t;
	return mx;
}

template <typename T>
T Vector_Min(vector<T> &V)
{
	T mn = V[0];
	for(T t : V)
		if(t < mn) mn = t;
	return mn;
}

template <typename T>
T Vector_Min_Index(vector<T> &V)
{
	if(V.size() == 0) return -1;
	int mi=0;
	for(int i = 0; i < V.size(); i++)
		if(V[i] < V[mi])
			mi = i;
	return mi;
}

template <typename T>
bool Vector_Is_Sorted(vector<T> &V)
{
	for(int i = 1; i < V.size(); i+=1)
		if(V[i] < V[i-1])
			return false;
	return true;
}

template <typename T> bool
Vector_All_Elements_Are_Equal(vector<T> &v)
{
	if(v.empty()) return true;
	T fir = v[0];
	for(T t : v)
		if(t != fir)
			return false;
	return true;
}

template <typename T>
T Vector_Max_Index(vector<T> &V)
{
	if(V.size() == 0) return -1;
	int mi = 0;
	for(int i = 0; i < V.size(); i++)
		if(V[i] > V[mi])
			mi = i;
	return mi;
}

template <typename T>
vector<T> Get_Divisors(T n){
	T root = sqrt(n);
	vector<T> v;
	for(T i = 1; i <= root; i++){
		if(n % i == 0) {
			v.push_back(i);
			T div = n/i;
			if(div != i)
				v.push_back(div);
		}
	}
	return v;
}

template <typename T>
bool Is_Prime(T n){
	return Get_Divisors(n).size() == 2;
}

template <typename T>
T Next_Prime_Divisor_From(T n, T from) {
	T root = sqrt(n);
	for(int i = from; i <= root; i++)
		if(n % i == 0) return i;
	return n;
}

template <typename T>
T GCD(T a, T b) {
	if(a < b) swap(a, b);
	while(b > 0) {
		T tmp = a%b;
		a = b;
		b = tmp;
	}
	return a;
}

template <typename T> bool Is_Perfect_Number(T n){
	return Vector_Sum(Get_Divisors(n)) == 2*n;
}

template <typename T>
void Build_Eratosthenes_Sieve(vector<T> &d, vector<T> &f, T n) {
	T k = 0;
	for(T i = 2; i <= n; i++){
		if(d[i] == 0){
			d[i] = i;
			f[k++] = i;
		}
		for(T a = 0; ; a++){
			if ( (a == k) || ((i*f[a])>n) || (f[a]>d[i])  )
				break;
			d[i * f[a]] = f[a];
		}
	}
}
