#include<bits/stdc++.h>
using namespace std;
#define pb push_back
#define ll long long
#define fr first
#define sc second
#define ARRS ((ll)(5e6+102))
#define MAXN ((ll)(1e9+100))
#define MAX ((ll)(1e18+101))
#define MOD ((ll)(1e9+7))

const double EPS = 1E-7;

struct pt {
    double x, y;
	 pt() {}
	 pt(double x, double y){
		 this->x = x;
		 this->y = y;
	 }

    bool operator<(const pt& p) const
    {
        return x < p.x - EPS || (abs(x - p.x) < EPS && y < p.y - EPS);
    }
};

struct line {
    double a, b, c;

    line() {}
    line(pt p, pt q)
    {
        a = p.y - q.y;
        b = q.x - p.x;
        c = -a * p.x - b * p.y;
        norm();
    }

    void norm()
    {
        double z = sqrt(a * a + b * b);
        if (abs(z) > EPS)
            a /= z, b /= z, c /= z;
    }

    double dist(pt p) const { return a * p.x + b * p.y + c; }
};

double det(double a, double b, double c, double d)
{
    return a * d - b * c;
}

inline bool betw(double l, double r, double x)
{
    return min(l, r) <= x + EPS && x <= max(l, r) + EPS;
}

inline bool intersect_1d(double a, double b, double c, double d)
{
    if (a > b)
        swap(a, b);
    if (c > d)
        swap(c, d);
		 return max(a, c) <= min(b, d) + EPS;
}

bool intersect(pt a, pt b, pt c, pt d, pt& left, pt& right)
{
    if (!intersect_1d(a.x, b.x, c.x, d.x) || !intersect_1d(a.y, b.y, c.y, d.y))
        return false;
    line m(a, b);
    line n(c, d);
    double zn = det(m.a, m.b, n.a, n.b);
    if (abs(zn) < EPS) {
        if (abs(m.dist(c)) > EPS || abs(n.dist(a)) > EPS)
            return false;
        if (b < a)
            swap(a, b);
        if (d < c)
            swap(c, d);
        left = max(a, c);
        right = min(b, d);
        return true;
    } else {
        left.x = right.x = -det(m.c, m.b, n.c, n.b) / zn;
        left.y = right.y = -det(m.a, m.c, n.a, n.c) / zn;
        return betw(a.x, b.x, left.x) && betw(a.y, b.y, left.y) &&
               betw(c.x, d.x, left.x) && betw(c.y, d.y, left.y);
    }
}



pair<pt, pt> getd(ll i){
	ll x=-i, y=i;
	ll d=3e8;
	return {pt(x-d, y-d), pt(x+d, y+d)};
}

ll fr[ARRS];

ll pw(ll a,ll b){
	ll p=1;
	while(b){
		if(b&1ll)p=(p*a)%MOD;
		a=(a*a)%MOD;
		b>>=1ll;
	}
	return p;
}

ll ce(ll n,ll k){
	return (((fr[n]*pw(fr[n-k], MOD-2))%MOD)*pw(fr[k], MOD-2))%MOD;
}

ll anw(ll d, ll l,ll r){
	return ((ce(r+d+1, d+1) - ce(l+d, d+1))%MOD+MOD)%MOD;
}


float sign (pt p1, pt p2, pt p3)
{
    return (p1.x - p3.x) * (p2.y - p3.y) - (p2.x - p3.x) * (p1.y - p3.y);
}

bool pit (pt pot, pt v1, pt v2, pt v3)
{
    double d1, d2, d3;
    bool has_neg, has_pos;

    d1 = sign(pot, v1, v2);
    d2 = sign(pot, v2, v3);
    d3 = sign(pot, v3, v1);

    has_neg = (d1 < 0) || (d2 < 0) || (d3 < 0);
    has_pos = (d1 > 0) || (d2 > 0) || (d3 > 0);

    return !(has_neg && has_pos);
}

int main() {
	ios::sync_with_stdio(0);

	fr[0]=1;
	for(ll i=1; i<ARRS; i++){
		fr[i]=(fr[i-1]*(ll)i)%MOD;
	}
	

	ll q;
	cin>>q;
	while(q--){
		ll x1,x2,x3,y1,y2,y3;
		cin>>x1>>y1>>x2>>y2>>x3>>y3;
		pt p1 = pt(x1, y1);
		pt p2 = pt(x2, y2);
		pt p3 = pt(x3, y3); 
		pt left;
		pt right;
		ll ans=0;

		for(ll d=0; d<=2e6+100; d++){
			pair<pt, pt> ln = getd(d);
			vector<pt> v;
			if(intersect(p1, p2, ln.fr, ln.sc, left, right)){
				if(left<right||right<left){
				} else {
					v.pb(left);
				}

			}
			if(intersect(p1, p3, ln.fr, ln.sc, left, right)){
				if(left<right||right<left){
				} else {
					v.pb(left);
				}
			}
			if(intersect(p3, p2, ln.fr, ln.sc, left, right)){
				if(left<right||right<left){
				} else {
					v.pb(left);
				}
			}
			if(v.size()==1)v.pb(v[0]);
			if(v.size()==0)continue;
			if(v[0].x>v[1].x)swap(v[0], v[1]);
			//ll l=int(v[0].x+d+1-EPS);
			ll l=ceil(v[0].x+d-EPS);
			l=max(l,0ll);
			ll r=floor(v[1].x+d+EPS);
			r=max(r,0ll);
			ll x=-d,y=d;

			for(int rr=-5; rr<=5; rr++){
				if(pit(pt(x+l+rr, y+l+rr), p1, p2, p3)){
					l=l+rr;
					break;
				}
			}
			for(int rr=5; rr>=-5; rr--){
				if(pit(pt(x+r+rr, y+r+rr), p1, p2, p3)){
					r=r+rr;
					break;
				}
			}


			if(l>r)continue;
			//cout<<d<<"; "<<l<<" --- "<<r<<endl;
			//cout<<anw(d, l, r)<<endl;
			ans=(ans+anw(d,l,r))%MOD;
			//for(auto k:v){
				//cout<<k.x<<" "<<k.y<<endl;
			//}
			//cout<<"?"<<endl;
		}
		cout<<ans<<endl;


	}
	

}
