#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>
//#include <assert.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-12;

vector<int> val;
int cnt = 1;
vector<int> ind;

void dfs1(int v, int sum) {
	if (sum == 0)
		return;
	
	if (val[v] == 0) {
		val[v] = 1;
		if (!ind[v])
			ind[v] = cnt++;
		--sum;
	}
	
	dfs1(v * 2, (sum + 1) / 2);
	dfs1(v * 2 + 1, sum / 2);
}

vector<pair<int, pair<int, int>>> ans;

void dfs2(int v) {
	if (val[v] == 0)
		return;
	
	ans[ind[v]] = {val[v], {val[v * 2] ? ind[v * 2] : 0, val[v * 2 + 1] ? ind[v * 2 + 1] : 0}};
	
	dfs2(v * 2);
	dfs2(v * 2 + 1);
}

void solve() {
	int a, b;
	cin >> a >> b;
	
	val.resize((1 << 23) + 10);
	ind.resize((1 << 23) + 10);
	ind[1] = cnt++;
	int last_i = -1;
	for (int i = 0; i < 20; ++i)
		if (b & (1 << i)) {
			for (int j = (1 << i); j < (1 << (i + 1)); ++j) {
				val[j] = 2;
				if (!ind[j])
					ind[j] = cnt++;
			}
			last_i = i;
		}
	
	int min_a = 0;
	for (int i = 0; i < last_i; ++i)
		if (!(b & (1 << i)))
			min_a += (1 << i);
	
	if (a < min_a) {
		cout << -1 << "\n";
		return;
	}
	
	dfs1(1, a);
	
	ans.resize(a + b + 1);
	dfs2(1);
	
	for (int i = 1; i <= a + b; ++i)
		cout << ans[i].first << " " << ans[i].second.first << " " << ans[i].second.second << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}