//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;


void debug_out()
{ cerr << endl; }

template<typename Head , typename... Tail>
void debug_out(Head H , Tail... T)
{
    cerr << "[" << H << "]";
    debug_out(T...);
}

#ifdef QWERTY
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif

clock_t startTime;

double getCurrentTime()
{
    return (double) ( clock() - startTime ) / CLOCKS_PER_SEC;
}

#define ALL(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
typedef long long ll;
typedef long double ld;

const int MOD = 1e9 + 7;

ll powmod(ll a , ll b)
{
    ll res = 1;
    a %= MOD;
    assert(b >= 0);
    for ( ; b ; b >>= 1 ) {
        if ( b & 1 ) res = res * a % MOD;
        a = a * a % MOD;
    }
    return res;
}

template<typename t1 , typename t2>
inline bool upmax(t1 &a , t2 b)
{
    if ( a < (t1) b ) {
        a = (t1) b;
        return true;
    } else return false;
}

template<typename t1 , typename t2>
inline bool upmin(t1 &a , t2 b)
{
    if ( a > (t1) b ) {
        a = (t1) b;
        return true;
    } else return false;
}

#define pii pair<int,int>
typedef vector<int> vi;
typedef vector<pair<int , int> > vpi;
#define N 400200


int l[N];
int r[N];
int sz[N];
int val[N];
int now = 2;
int ones = 0;

void put(int v)
{
    if ( val[v] == 0 ) {
        val[v] = 1;
        sz[v] = 1;
    } else {
        if ( r[v] == 0 ) {
            r[v] = now++;
            put(r[v]);
        } else if ( l[v] == 0 ) {
            l[v] = now++;
            put(l[v]);
        } else if ( sz[l[v]] < sz[r[v]] ) {
            put(l[v]);
        } else put(r[v]);

        sz[v] = sz[l[v]] + sz[r[v]] + val[v];
    }
}

void dfs(int v , int cnt)
{
    cnt--;
    val[v] = 2;
    if ( cnt == 0 ) return;

    int left = ( cnt + 1 ) / 2;
    int right = cnt / 2;

    l[v] = now++;
    dfs(l[v] , left);

    if ( right != 0 ) {
        r[v] = now++;
        dfs(r[v] , right);
    }

    while (r[v] == 0 || l[v] == 0 || sz[l[v]] > sz[r[v]] + 1) {
        put(v);
        ones++;
    }
    sz[v] = sz[l[v]] + sz[r[v]] + val[v];
}

void solve(int TC)
{
    int a , b;
    cin >> a >> b;
    dfs(1 , b);
    while (ones < a) {
        put(1);
        ones++;
    }
    if ( ones > a ) {
        cout << -1 << endl;
        return;
    }
    for ( int i = 1 ; i < now ; i++ ) {
//        if ( l[i] ) cerr << i << ' ' << l[i] << endl;
//        if ( r[i] ) cerr << i << ' ' << r[i] << endl;
        printf("%d %d %d\n",val[i],l[i],r[i]);
    }
}

int main()
{
    startTime = clock();
#ifdef QWERTY
    freopen("input.txt" , "r" , stdin);
    freopen("output.txt" , "w" , stdout);
#endif
//    ios_base::sync_with_stdio(false);
    int T = 1;
//    cin >> T;
    for ( int i = 1 ; i <= T ; i++ ) {
        cerr << "Case #" << i << ":" << endl;
#ifdef QWERTY
        cout << "Case #" << i << ":" << endl;
#endif
        solve(T);
    }
    cerr << "Time: " << getCurrentTime() << " ms" << endl;
    return 0;
}
