#include <bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define L first
#define R second

typedef long long ll;
typedef pair<ll, ll> point;
typedef pair<ll, ll> interval;

const ll MAXX = 1 << 20;
const ll MOD = 1000000007;

point operator-(point A, point B) {
  return {A.X - B.X, A.Y - B.Y};
}

ll operator^(point A, point B) {
  return A.X * B.Y - A.Y * B.X;
}

ll area(point A, point B, point C) {
  return (C - B) ^ (A - B);
}

interval operator|(interval A, interval B) {
  interval ret = {max(A.L, B.L), min(A.R, B.R)};
  if (ret.L >= ret.R)
    ret = {0, 0};
  return ret;
}

interval intersection(const vector<point> &P, ll line) {
  // cout << "calcualting intersection " << endl;
  auto eq = [line](ll x) {
    return point(-line + x, line + x);
  };
  vector<interval> insides(P.size());
  for (int i = 0; i < P.size(); i++) {
    // cout << "working on segment " << i << " " << (i + 1) % P.size() << endl;
    auto f = [P, i, eq](ll x) {
      point A = eq(x);
      if (area(A, P[i], P[(i + 1) % P.size()]) >= 0)
        return 1;
      return 0;
    };

    ll l = 0, r = MAXX;
    if (f(l) == 0 && f(r - 1) == 0)
      insides[i] = {0, 0};
    else if (f(l) == 1 && f(r - 1) == 1)
      insides[i] = {l, r};
    else {
      bool invert = f(l) == 1;
      auto g = [invert, f](ll x) {
        if (invert)
          return 1 - f(x);
        return f(x);
      };
      // cout << "inverting " << invert << endl;
      // cout << "performing binary search " << endl;
      ll st = l, en = r;
      while (st + 1 < en) {
        int mid = (st + en) >> 1;
        if (g(mid) == 1)
          en = mid;
        else
          st = mid;
      }
      if (g(st) == 1)
        en = st;
      // cout << "binary search returned " << en << endl;
      if (!invert)
        insides[i] = {en, MAXX};
      else
        insides[i] = {0, en};
    }
    // cout << "got result " << insides[i].L << " " << insides[i].R << endl;
  }
  interval ret = {0, MAXX};
  for (auto it : insides)
    ret = ret | it;
  // cout << "have overall result " << ret.L << " " << ret.R << endl;
  return ret;
}

int main() {
  int TC;
  cin >> TC;
  while (TC--) {
    vector<point> P(3);
    for (int i = 0; i < 3; i++)
      cin >> P[i].X >> P[i].Y;
    if (area(P[0], P[1], P[2]) < 0)
      reverse(P.begin(), P.end());
    ll ans = 0;
    for (ll line = 0; line < MAXX; line++) {
      interval inside = intersection(P, line);
      auto S = [](ll i, ll x0, ll r) {
        ll ret = x0 * (i) + i * (i - 1) / 2ll * r;
        return ret % MOD;
      };
      // cout << "adding " << S(inside.R, 1ll, line) - S(inside.L, 1ll, line) << endl;
      ans =
          (ans + S(inside.R, 1ll, line) - S(inside.L, 1ll, line) + MOD + MOD) %
          MOD;
    }
    cout << ans << endl;
  }

  return 0;
}