//#define FILEINOUT

//==========================    INCLUDES    ====================================================
#include <iostream>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <iterator>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <utility>
#include <malloc.h>
//=================================================================================================

using namespace std;

//==========================    FILES    ==========================================================
#ifdef FILEINOUT
ifstream In("input.txt");
ofstream Out("output.txt");
#else
#define In cin
#define Out cout
#endif
//=================================================================================================

//==========================    DEFINES    ========================================================
#define fori(x) for (ll i = 0; i < (x); i++)
#define fordi(x) for (ll i = (x - 1); i >= 0; i--)
#define forj(x) for (ll j = 0; j < (x); j++)
#define fordj(x) for (ll j = (x - 1); j >= 0; j--)
#define forn(i, n) for (ll i = 0; i < (n); i++)
#define fordn(i, n) for (ll i = (n - 1); i >= 0; i--)
#define FOR(i, a, b) for (ll i = (a); i < (b); i++)
#define FORD(i, a, b) for (ll i = (a); i >= (b); i--)
#define forin(x) for (auto &t : (x))
#define For(i, start, cond, dif) for (ll i = (start); (cond); (dif))
#define ever() for (;;)
#define min3(a, b, c) min(ll(a), min(ll(b), ll(c)))
#define max3(a, b, c) max(ll(a), max(ll(b), ll(c)))
#define abs0(x) max(ll(0), ll(x))
#define pow2(x) ((x) * (x))
#define pow3(x) ((x) * (x) * (x))
#define close_int(x) ((ll)((ld)(x) + 0.5))
#define is_2_power() (x && (!(x&(x-1)))
#define all(x) (x).begin(), (x).end()
#define dosort(x) sort(all(x))
#define doreverse(x) reverse(all(x))
#define improve(a, b) (a = (a < (b) ? (b) : a))
#define deimprove(a, b) (a = (a > (b) ? (b) : a))
#define fastIO ios::sync_with_stdio(NULL); In.tie(NULL); Out.tie(NULL)
#define read(x) for (auto &t : (x)) In >> t
#define write(x) for (auto &t : (x)) Out << t << ' ';
#define watch(x) cout << (#x) << " --> " << (x) << endl
#define endl '\n'
#define space ' '
#define in(x) ll x; In >> x
#define sz(x) ((ll)(x).size())
#define ff first
#define ss second
#define mp make_pair
#define pb push_back
//=================================================================================================

//==========================    TYPES    ==========================================================
typedef long long  ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef pair<ll, ii> iii;
typedef pair<double, double> dd;
typedef vector<ll> vi;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<string> vs;
typedef vector<double> vd;
typedef vector<ii> vii;
typedef vector<dd> vdd;
typedef vector<vi> vvi;
typedef vector<vb> vvb;
typedef vector<vc> vvc;
typedef set<ll> si;
typedef set<double> sd;
typedef set<string> ss;
typedef set<char> sc;
typedef map<ll, ll> mii;
typedef map<ll, double> mid;
typedef map<string, ll> msi;
typedef unordered_set<ll> usi;
typedef unordered_set<double> usd;
typedef unordered_set<string> uss;
typedef unordered_set<char> usc;
typedef unordered_map<ll, ll> umii;
typedef unordered_map<ll, double> umid;
typedef unordered_map<string, ll> umsi;
typedef queue<ll> qi;
typedef queue<ii> qii;
typedef priority_queue<ll> maxheap;
typedef priority_queue <ll, vi, greater<ll> > minheap;
typedef deque<ll> deqi;
//=================================================================================================

//=====================         CONST       =======================================================
const ld ZERO = 1e-15;
const ld EPS = 1e-10;
const ll MAXN = 100500;
const ll INF9 = 2 * 1e9;
const ll INF = 2 * 1e18;
const ld PI = acos(-1);
const ld SQRT2 = sqrt(2.0);
const ll MAXMOD = 1e9 + 7;
//=================================================================================================

//=====================    FUNC DECLARATIONS    ===================================================

//=====================      NUMBER THEORY      ===================================================
ll modulo_power(ll a, ll p, ll m); // returns (a ^ p) % m
bool fermat(ll p,ll iterations); // returns whether number is prime
bool is_prime_sqrt(ll n);
bool is_prime_fermat(ll p); // returns whether number is prime
vi eratosphen(ll n); // returns all primes no greater than n
void prime_divisors_extended(vii& divisors, ll number); // returns factorisation of number
void prime_divisors(vi& divisors, ll number); // returns sorted list of all prime divisors of number
void all_divisors(vi& divisors, ll number); // returns sorted list of all divisors of number
ll gcd(ll a, ll b); //returns GCD(a, b); GCD(0, n) = n
ll combinations(ll n, ll k); // returns number of combinations from n to k
ll factorial(ll n); // returns factorial
string long_minus(string a, string b); // returns result of a - b
string from_decimal_numeral_system_to_other (ll number, ll base); // transfers from decimal to system with other base
ll from_other_numeral_system_to_decimal (string number, ll base);
//=================================================================================================

//=====================         STRING           ==================================================
ll compare_string(string& a, string& b); // compares 2 strings
void cycle_permutation(string& s); // returns cycle permutation (1234)->(2341)
vi pref_function(string s); // pref function for string
//=================================================================================================

//=====================        GEOMETRY           =================================================
double triangle_square(double x1, double y1, double x2, double y2, double x3, double y3); // square of triangle
ll point_to_line_location(double x, double y, double xa, double ya, double xb, double yb); //      
ll length_of_collective_segment(ll ax1, ll ax2, ll bx1, ll bx2); //    
dd lines_intersection_point(double a1, double b1, double c1, double a2, double b2, double c2); //    
//=================================================================================================

//=====================          OTHER            =================================================
void segmented_sieve(vi& v, ll l, ll r);
void sieve(vi& v, ll number);
template<class T>
ll binary_search(vector<T>& v, T k, bool more_or_equal);  // returns the index of the more or equal (less or equal) element in the array
//=================================================================================================

//=====================    YOUR FUNC DECLARATIONS    ==============================================

//YOUR FUNC DECLARATIONS HERE

//=================================================================================================

//=====================           CODE            =================================================
int main()
{
    fastIO;

    in(t);
    while (t--)
    {
      in(b);
      in(d);
      ll nod = gcd(b, d);
      ll ost = b / nod;
      ll sq_b = b * b;
      ll ans = (sq_b - 1) / ost / d;
      Out << ans << endl;

    }



    return 0;
}
//=================================================================================================

//=====================    YOUR FUNC REALISATIONS    ==============================================

//YOUR FUNC REALISATIONS HERE

//=================================================================================================

//=====================     FUNC REALISATIONS     =================================================
ll modulo_power(ll a, ll p, ll m)
{
    ll x = 1;
    ll y = a;
    while (p > 0)
    {
        if (p & 1)
            x = (x * y) % m;
        y = (y * y) % m;
        p >>= 1;
    }
    return x % m;
}
bool is_prime_sqrt(ll n)
{
    if (n == 1)
         return false;
	for(ll i = 2; i <= sqrt(n); i++)
	{
	    if(n % i == 0)
            return false;
	}
	return true;
}
bool fermat(ll p, ll iterations)
{
    if(p == 1)
        return 0;
    fori(iterations)
    {
        ll a = rand() % (p - 1) + 1;
        if (modulo_power (a, p - 1, p) != 1)
            return false;
    }
    return true;
}

bool is_prime_fermat(ll p)
{
    return fermat(p, 10);
}

void prime_divisors_extended(vii& divisors, ll number)
{
    if (number % 2 == 0)
    {
        ll cnt = 0;
        while (number % 2 == 0)
        {
            number /= 2;
            ++cnt;
        }
        if (cnt)
            divisors.push_back({2, cnt});
    }
    ll start_number = number;
    for (ll p = 3; p <= number && p * p <= start_number; p += 2)
    {
        ll cnt = 0;
        while (number % p == 0)
        {
            number /= p;
            ++cnt;
        }
        if (cnt) divisors.push_back({p, cnt});
    }
    if (number != 1)
        divisors.push_back({number, 1});
}

void prime_divisors(vi& divisors, ll number)
{
    if (number % 2 == 0)
    {
        divisors.push_back(2);
        while (!(number % 2)) number /= 2;
    }
    ll start_number = number;
    for (ll p = 3; p <= number && p * p <= start_number; p += 2)
    {
        if (number % p)
            continue;
        divisors.push_back(p);
        while (!(number % p))
            number /= p;
    }
    if (number - 1)
        divisors.push_back(number);
}

void all_divisors(vi& divisors, ll number)
{
    if (number % 2 == 0)
    {
        divisors.push_back(2);
        if (4 != number)
        {
            divisors.push_back(number / 2);
        }
    }
    for (ll p = 3; p * p <= number; p += 2)
    {
        ll cnt = 0, t = p;
        if (number % t == 0)
        {
            divisors.push_back(p);
            if (p * p != number)
            {
                divisors.push_back(number / p);
            }
        }
    }
    dosort(divisors);
}

ll compare_string (string& a, string& b)
{
    a = string(abs0(b.size() - a.size()), '0') + a;
    b = string(abs0(a.size() - b.size()), '0') + b;
    fori(a.size())
    {
        if (a[i] > b[i])
            return 1;
        if (a[i] < b[i])
            return -1;
    }
    return 0;
}

string long_minus(string a, string b) {
    a = string(abs0(b.size() - a.size()), '0') + a;
    b = string(abs0(a.size() - b.size()), '0') + b;
    if (!compare_string(a, b)) return "0";
    bool negative = false;
    if (compare_string(a, b) == -1) {
        swap(a, b);
        negative = true;
    }
    ll len = a.size();
    string result(len, '0');
    bool need = false;
    fordi(len) {
        if (need) a[i]--;
        need = false;
        if (a[i] < b[i]) need = true;
        result[i] = (a[i] - '0' + 10 - (b[i] - '0')) % 10 + '0';
    }
    ll cnt0 = 0;
    while (result[cnt0] == '0') cnt0++;
    result = result.substr(cnt0, len - cnt0);

    return (negative ? "-" : "") + result;
}

void cycle_permutation(string& s) {
    string tmp = s.substr(0, 1);
    s = s.substr(1, s.size() - 1) + tmp;
    return;
}

template<class T>
ll binary_search(vector<T>& v, T k, bool more_or_equal)  // returns the index of the more or equal (less or equal) element in the array
{
    ll l = 0, r = v.size() - 1, m;
    while (l + 1 < r) {
        m = (l + r) / 2;
        if (v[m] > k) r = m;
        else l = m;
    }
    if (more_or_equal) {
        if (v[l] >= k) return l;
        return r;
    }
    else {
        if (v[r] <= k) return r;
        return l;
    }
}

string from_decimal_numeral_system_to_other (ll number, ll base)
{
    if (!number)
        return "0";
    string ans;
    for (; number ; number /= base)
    {
        ll digit = number % base;
        if (digit < 10)
            ans.push_back(digit + '0');
        else
            ans.push_back(digit - 10 + 'A');
    }
    reverse(ans.begin(),ans.end());
    return ans;
}

ll from_other_numeral_system_to_decimal (string number, ll base)
{
    ll ans = 0;
    for (ll i = 0; i < number.size() ; i++)
    {
        char digit = number[i];
        ans *= base;
        if ((digit <= '9') &&
            (digit >= '0'))
            ans += digit - '0';
        else
            ans += digit - 'A' + 10;
    }

    return ans;
}

ll gcd(ll a, ll b) {
    if (!(a || b)) return 0;
    return (b ? gcd(b, a % b): a);
}

ll combinations(ll n, ll k) {
    return (k && n - k) ? combinations(n - 1, k) + combinations(n - 1, k - 1) : 1;
}

ll factorial(ll n) {
    return (n > 1) ? n * factorial(n - 1) : 1;
}

double triangle_square(double x1, double y1, double x2, double y2, double x3, double y3)
{
    return (double)((x2 - x1) * (y3 - y1) - (y2 - y1) * (x3 - x1)) / 2;
}

ll point_to_line_location (double x, double y, double xa, double ya, double xb, double yb)
{
    double x1 = xb - xa;
    double y1 = yb - ya;
    double x2 = x - xa;
    double y2 = y - ya;
    if (x1*y2 - x2 * y1 < 0)
    {
        return -1;
    }
    if (x1*y2 - x2 * y1 > 0)
    {
        return 1;
    }
    return 0;
}


ll length_of_collective_segment(ll ax1, ll ax2, ll bx1, ll bx2)
{
    if (ax2 < bx1)
    {
        return 0;
    }
    if (ax1 <= bx1 && ax2 < bx2)
    {
        return ax2 - bx1;
    }
    if (ax1 <= bx1 && ax2 >= bx2)
    {
        return bx2 - bx1;
    }
    if (ax1 >= bx1 && bx2 >= ax2)
    {
        return ax2 - ax1;
    }
    if (ax1 > bx1 && bx2 >= ax1 && ax2 > bx2)
    {
        return bx2 - ax1;
    }
    return 0;
}

dd lines_intersection_point (double a1, double b1, double c1, double a2, double b2, double c2)
{
    dd xy;

    if (a1 == 0)
    {
        xy.second = c1 / b1;
        xy.first = (c2 - b2 * xy.second) / a2;
        return xy;
    }

    if (a2 == 0)
    {
        xy.second = c2 / b2;
        xy.first = (c1 - b1 * xy.second) / a1;
        return xy;
    }

    xy.second = (c2*a1 - a2 * c1) / (b2*a1 - a2 * b1);
    xy.first = (c1 - b1 * xy.second) / a1;
    return xy;
}

vi pref_function(string s)
{
    vi p(s.size(), 0);
    for (ll i = 1; i < s.size(); i++)
    {
        ll k = p[i - 1];
        while (k > 0 && s[i] != s[k])
        {
            k = p[k - 1];
        }
        if (s[i] == s[k])
        {
            k++;
            p[i] = k;
        }
    }
    return p;
}

vi eratosphen(ll n)
{
    vb prime(n + 1, true);
    prime[0] = prime[1] = false;
    ll size = n;
    if(!n)
        size = 1;
    for(ll i = 2; i <= n; i++)
    {
        if (prime[i])
        {
            for (ll j = i * i; j <= n; j += i)
            {
                if(prime[j])
                {
                    prime[j] = false;
                    size--;
                }
            }
        }
    }
    vi res(size);
    ll ind = 0;
    for (ll i = 0; i <= n && ind < size; i++)
    {
        if (prime[i])
        {
            res[ind] = i;
            ind++;
        }
    }
    return res;
}

