#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <fstream>
#include <vector>
#include <queue>
#include <stack>
#include <sstream>
#include <list>
#include <map>
#include <set>
#include <limits>
#include <random>
#include <functional>
#include <unordered_set>
#include <unordered_map>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int ui;

#define pii pair<int, int>
#define pll pair<ll, ll>
#define vi vector<int>
#define vl vector<ll>

using namespace std;

const int N = 100010;
const int M = 100010;
const int MOD = 1000000007;
const int INF = 1009000999;
const ll LINF = (1ll << 60) + 1337;
const ld EPS = 0.0000000001;

struct item {
	int w, l, r;
	item() {};
	item(int w, int l, int r) : w(w), l(l), r(r) {};
};

int tree[8 * N];
int c1, c2;
int sz[8 * N];
int depth = 0;
vector<item> ans;
int code[8 * N];
int last = 1;

bool can = true;

void clr(int x, int cnt, int d = 0) {
	if (cnt <= 0) {
		return;
	}
	depth = max(d, depth);
	tree[x] = 2;
	cnt--;
	clr(2 * x + 1, cnt / 2, d + 1);
	clr(2 * x + 2, cnt / 2 + cnt % 2, d + 1);
}

void prepare(int x, int d = 0) {
	if (d == depth) {
		if (tree[x] == 0) {
			if (c1 > 0) {
				tree[x] = 1;
				c1--;
			}
		}
		return;
	}
	else {
		prepare(2 * x + 1, d + 1);
		prepare(2 * x + 2, d + 1);
	}
}

void clr2(int x, int cnt) {
	if (cnt <= 0) {
		return;
	}
	if (tree[x] == 0) {
		tree[x] = 1;
		cnt--;
	}
	clr2(2 * x + 1, cnt / 2 + cnt % 2);
	clr2(2 * x + 2, cnt / 2);
}

void check(int x) {
	if (tree[x] == 0) {
		sz[x] = 0;
	}
	else {
		check(2 * x + 1);
		check(2 * x + 2);
		if (abs(sz[2 * x + 1] - sz[2 * x + 2]) > 1) can = false;
		sz[x] = tree[x] + sz[2 * x + 1] + sz[2 * x + 2];
	}
	return;
}

void build_ans(int x) {
	queue<int> q;
	q.push(x);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		if (tree[v] == 0) continue;
		int w = tree[v];
		int l = 2 * v + 1;
		int r = 2 * v + 2;
		q.push(l);
		q.push(r);
		ans.push_back(item(w, code[l], code[r]));
	}
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	cin >> c1 >> c2;
	clr(0, c2);
	prepare(0);
	clr2(0, c1);
	check(0);
	if (can) {
		for (int i = 0; i < 8 * N; i++) {
			if (tree[i] != 0) {
				code[i] = last;
				last++;
			}
		}
		build_ans(0);
		for (auto& i : ans) {
			cout << i.w << " " << i.l << " " << i.r << "\n";
		}
	}
	else {
		cout << -1;
	}
}

/*
	Important stuff
	- int overflow
	- array bounds
	- special cases (n=1, max n) maybe adhoc problem
	- doubles are read for a long time (4 * 10 ^ 5 danger GNU vs MS ICPC 2020 1/4)
	- don't get stuck on one approach
	- don't get stuck on one problem
	- recheck submissions if near the end of the tournament and there is nothing to do
	- do something instead of nothing and stay organized
*/