#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <fstream>
#include <vector>
#include <queue>
#include <stack>
#include <sstream>
#include <list>
#include <map>
#include <set>
#include <limits>
#include <random>
#include <functional>
#include <unordered_set>
#include <unordered_map>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int ui;

#define pii pair<int, int>
#define pll pair<ll, ll>
#define vi vector<int>
#define vl vector<ll>

using namespace std;

const int N = 200010;
const int M = 100010;
const int MOD = 1000000007;
const int INF = 1009000999;
const ll LINF = (1ll << 60) + 1337;
const ld EPS = 0.0000000001;

struct item {
	int min;
	int max;
	int left;
	int right;
	int key;
	int count;
	item() {};
};

int n;
item tree[N];

void calc(int x) {
	if (tree[x].left != 0) {
		calc(tree[x].left);
		tree[x].min = min(tree[tree[x].left].min, tree[x].min);
		tree[x].max = max(tree[tree[x].left].max, tree[x].max);
		tree[x].count += tree[tree[x].left].count;
	}
	if (tree[x].right != 0) {
		calc(tree[x].right);
		tree[x].min = min(tree[tree[x].right].min, tree[x].min);
		tree[x].max = max(tree[tree[x].right].max, tree[x].max);
		tree[x].count += tree[tree[x].right].count;
	}
}

void lookUp(int x, int l, int r, int & cnt) {
	cnt++;
	//cout << x << "\n";
	if (x <= 0 || x >= n) return;
	if (l <= tree[x].min && tree[x].max <= r) return;
	if (tree[x].max < l || r < tree[x].min) return;
	lookUp(tree[x].left, l, r, cnt);
	lookUp(tree[x].right, l, r, cnt);
	return;
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> tree[i].left >> tree[i].right >> tree[i].key;
		tree[i].count = 1;
		tree[i].max = tree[i].min = tree[i].key;
	}
	calc(1);
	int q;
	cin >> q;
	while (q--) {
		int l, r;
		cin >> l >> r;
		int cnt = 0;
		lookUp(1, l, r, cnt);
		//cout << "\n";
		cout << cnt << "\n";
	}
}

/*
	Important stuff
	- int overflow
	- array bounds
	- special cases (n=1, max n) maybe adhoc problem
	- doubles are read for a long time (4 * 10 ^ 5 danger GNU vs MS ICPC 2020 1/4)
	- don't get stuck on one approach
	- don't get stuck on one problem
	- recheck submissions if near the end of the tournament and there is nothing to do
	- do something instead of nothing and stay organized
*/