#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

struct nodeInfo
{
	int leftChild, rightChild, weight;
	nodeInfo(int l, int r, int w)
	{
		leftChild = l;
		rightChild = r;
		weight = w;
	}
	nodeInfo()
	{
		nodeInfo(0, 0, 0);
	}
};

int a, b, skip = 0;
bool ansFound = true;
vector<nodeInfo> ans;
vector<int> levels;

void rec(int A, int B, int curInd, int level)
{
	//cout << "rec: " << A << " " << B << " " << curInd << " " << level << "\n";
	int total = A + 2 * B, need;
	if (total == 0)
	{
		return;
	}
	if (A < 0 || B < 0)
	{
		return;
	}
	if (B % 2 == 0 && A == 0)
	{
		ansFound = false;
		return;
	}
	if (B > 0)
	{
		ans[curInd].weight = 2;
		total -= 2;
		B--;
	}
	else
	{
		ans[curInd].weight = 1;
		total--;
		A--;
	}
	if (total == 0)
	{
		return;
	}
	need = total / 2;
	if (2 * B >= need)
	{
		if (min(A, need % 2) + need / 2 != 0)
		{
			if (levels[level + 1] == 0)
			{
				ans[curInd].leftChild = pow(2, level + 1);
			}
			else
			{
				ans[curInd].leftChild = levels[level + 1] + 1;
			}
			levels[level + 1] = ans[curInd].leftChild;
			rec(min(A, need % 2), need / 2, ans[curInd].leftChild, (level + 1));
		}
		if (A - (min(A, need % 2)) + B - need / 2 != 0)
		{
			if (levels[level + 1] == 0)
			{
				ans[curInd].rightChild = pow(2, level + 1);
			}
			else
			{
				ans[curInd].rightChild = levels[level + 1] + 1;
			}
			levels[level + 1] = ans[curInd].rightChild;
			rec(A - (min(A, need % 2)), B - need / 2, ans[curInd].rightChild, (level + 1));
		}
	}
	else
	{
		if (need - 2 * B <= A)
		{
			if (need - 2 * B + B != 0)
			{
				if (levels[level + 1] == 0)
				{
					ans[curInd].leftChild = pow(2, level + 1);
				}
				else
				{
					ans[curInd].leftChild = levels[level + 1] + 1;
				}
				levels[level + 1] = ans[curInd].leftChild;
				rec(need - 2 * B, B, ans[curInd].leftChild, (level + 1));
			}
			if (A - (need - 2 * B) != 0)
			{
				if (levels[level + 1] == 0)
				{
					ans[curInd].rightChild = pow(2, level + 1);
				}
				else
				{
					ans[curInd].rightChild = levels[level + 1] + 1;
				}
				levels[level + 1] = ans[curInd].rightChild;
				rec(A - (need - 2 * B), 0, ans[curInd].rightChild, (level + 1));
			}
		}
		else
		{
			ansFound = false;
			return;
		}
	}
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> a >> b;
	ans.resize(4*(a + b + 1), nodeInfo(0, 0, 0));
	levels.resize(a + b + 1, 0);
	rec(a, b, 1, 0);
	if (ansFound)
	{
		for (int i = 1; i <= 4 * (a + b); i++)
		{
			if (ans[i].weight == 0)
			{
				continue;
			}
			cout << ans[i].weight << " " << ans[i].leftChild << " " << ans[i].rightChild << "\n";
		}
	}
	else
	{
		cout << -1;
	}
	return 0;
}