
//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define sz(a) ((int)(a).size())
#define X first
#define Y second

using ll = long long;
using ull = unsigned long long;
using dbl = long double;
using pii = pair<int, int>;

const ll inf = (ll)1e9;
const int N = (int)1e6 + 66;
const ll mod = (ll)1e9 + 7;

inline ll inv(ll x){
    ll res = 1, pw = mod - 2;
    while(pw){
        if(pw&1)
            res = res * x % mod;
        x = x * x % mod;
        pw >>= 1;
    }
    return res;
}

ll fac[N], ifac[N];
ll x[3], y[3];

inline ll C(int n, int k){
    if(k > n)
        return 0;
    return fac[n] * ifac[k] % mod * ifac[n - k] % mod;
}

inline ll prefix(int k, int n){
    return k > n ? 0 : C(n + 1, k + 1);
}

void precalc(){
    fac[0] = ifac[0] = 1;
    for(int i = 1; i < N; i++){
        fac[i] = fac[i - 1] * i % mod;
        ifac[i] = inv(fac[i]);
    }
}

inline pair<ll, ll> intersect(int k){
    ll L[3], R[3];
    for(int i = 0; i < 3; i++){
        int j1 = (i + 1)%3;
        int j2 = (i + 2)%3;
        ll A = y[j1] - y[j2];
        ll B = x[j2] - x[j1];
        ll C = -B * y[j1] - A * x[j1];
        ll Q = -C - 2*k*B;
        ll P = A + B;
        if(!P){
            if(Q <= 0){
                L[i] = -inf, R[i] = inf;
            }
            else{
                L[i] = inf, R[i] = -inf;
            }
        }
        else{
            if(P > 0){
                L[i] = Q/P; R[i] = inf;
                if(Q%P != 0 && Q > 0)++L[i];
            }
            else{
                R[i] = (-Q)/(-P); L[i] = -inf;
                if(Q%P != 0 && Q > 0)--R[i];
            }
        }
    }
    ll l = max({L[0], L[1], L[2]});
    ll r = min({R[0], R[1], R[2]});
    return make_pair(l + 2*k, r + 2*k);
}

void solve() {
    for(int i = 0; i < 3; i++)
        cin >> x[i] >> y[i];
    ll kek = (x[1] - x[0]) * (y[2] - y[0]) - (x[2] - x[0]) * (y[1] - y[0]);
    if(kek < 0){
        reverse(x, x + 3);
        reverse(y, y + 3);
    }
    ll ans = 0;
    for(int k = 0; k < N; k++){
        int L, R;
        tie(L, R) = intersect(k);
        if(L <= R){
            //cerr << "FUGG " << k << ' '  << L << ' ' << R << endl;
            ans += prefix(k, R) - prefix(k, L - 1);
            ans %= mod;
        }
    }
    cout << (ans%mod + mod)%mod << endl;
}

signed main() {
#ifdef LOCAL
     assert(freopen("input.txt", "r", stdin));
     //assert(freopen("output.txt", "w", stdout));
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);
    precalc();
    int T;
    cin >> T;
    while(T--)
	    solve();

#ifdef LOCAL
    cout << endl << endl << "time = " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
}


