//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,tune=native")
#include <bits/stdc++.h>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define sz(a) ((long long)(a).size())
#define X first
#define Y second

using ll = long long;
using ull = unsigned long long;
using dbl = long double;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll mod) {
    return (ull)rng() % mod;
}

int n;
bool used[44][44];

bool can(int i, int j) {
    if (i < -n || i > n || j < -n || j > n)
        return false;
    int li, ri;
    if (j <= 0) {
        li = -n + abs(j);
        ri = n;
    } else {
        li = -n;
        ri = n - abs(j);
    }
    return li <= i && i <= ri && !used[i + n][j + n];
}

const int inf = 1e9;
const vector<pair<int, int>> MVS = {
    {1, 0},
    {0, 1},
    {-1, 1},
    {-1, 0},
    {0, -1},
    {1, -1},
};
int ans = 0;

void play1() {
    memset(used, 0, sizeof used);
    int x = n / 2;
    int y = 0;
    int cnt_moves = 0;
    while (1) {
        ++cnt_moves;
        vector<pair<int, int>> cells;
        for (auto mv : MVS) {
            int tx = x + mv.X;
            int ty = y + mv.Y;
            if (can(tx, ty)) {
                cells.push_back({tx, ty});
            }
        }
        if (cells.empty()) {
            break;
        }
        auto to = cells[myRand(sz(cells))];
        used[x + n][y + n] = 1;
        x = to.X;
        y = to.Y;
    }

    ans = max(ans, cnt_moves);
    // cout << cnt_moves << endl;
}

const int DEBUG = 0;

#define y1 kasmdklsac

pair<int, int> get_op_move(int x, int y) {
    if (DEBUG) {
        vector<pair<int, int>> cells;
        for (auto mv : MVS) {
            int tx = x + mv.X;
            int ty = y + mv.Y;
            if (can(tx, ty)) {
                cells.push_back({tx, ty});
            }
        }
        if (cells.empty()) {
            return {-inf, -inf};
        }
        return cells[myRand(sz(cells))];
    } else {
        string s;
        cin >> s;
        if (s == "win") {
            return {-inf, -inf};
        }
        if (s == "lose") {
            return {inf, inf};
        }
        int dx, dy;
        cin >> dx >> dy;
        return {x + dx, y + dy};
    }
}

int get_dist(int x0, int y0, int x1, int y1, int x2, int y2) {
    y0 = y0;
    y1 = y1;
    y2 = y2;
    int z1 = x0;
    // if (y1 < 0) {
    //     z1 += abs(y1);
    // }
    int z2 = x0;
    // if (y2 < 0) {
    //     z2 += abs(y2);
    // }
    if (x2 > z2 || 1) {
        if (x1 > z1) {
            return inf + z1 - x1;
        }
        return z1 - x1;
    } else {
        if (x1 < z1) {
            return inf + x1 - z1;
        }
        return x1 - z1;
    }
    // return max(abs(x1 - x0), abs(y1 - y0));
}


bool used1[44][44];

int dfs(int x, int y) {
    if (used1[x + n][y + n])
        return 0;
    used1[x + n][y + n] = 1;
    int res = 1;
    for (auto mv : MVS) {
        int tx = x + mv.X;
        int ty = y + mv.Y;
        if (can(tx, ty)) {
            res += dfs(tx, ty);
        }
    }
    return res;
}


void play() {
    memset(used, 0, sizeof used);

    int x0 = -n / 2;
    int y0 = 0;
    int x1 = n / 2;
    int y1 = 0;

    int st_x0 = x0;
    int st_y0 = y0;

    used[x0 + n][y0 + n] = 1;
    used[x1 + n][y1 + n] = 1;

    int cnt_moves = 0;
    while (1) {
        ++cnt_moves;
        vector<pair<pair<int, int>, pair<int, int>>> cells;
        for (auto mv : MVS) {
            int tx = x0 + mv.X;
            int ty = y0 + mv.Y;
            if (can(tx, ty)) {
                int cnt = dfs(tx, ty);
                int dist = get_dist(st_x0, st_y0, tx, ty, x1, y1);
                pair<int, int> val;
                // if (dist == inf) {
                //     val = {inf, inf};
                // } else {
                val = {dist, -cnt};
                // }
                if (!cells.empty() && val < cells[0].Y) {
                    cells.clear();
                }
                if (cells.empty() || val == cells[0].Y) {
                    cells.push_back({{tx, ty}, val});
                }
            }
        }
        if (cells.empty()) {
            cout << "CANT " << cnt_moves << " " << x0 << " " << y0 << " " << x1 << " " << y1 << endl;
            assert(false);
        }
        auto to0 = cells[myRand(sz(cells))].X;
        if (!DEBUG) {
            cout << to0.X - x0 << ' ' << to0.Y - y0 << endl;
        }
        x0 = to0.X;
        y0 = to0.Y;
        used[x0 + n][y0 + n] = 1;
        // cout << x0 << " " << y0 << endl;

        auto to1 = get_op_move(x1, y1);
        if (to1.X == -inf) {
            if (DEBUG) {
                cout << "WIN" << endl;
            }
            return;
        }
        if (to1.X == inf) {
            cout << "FUCK" << endl;
            assert(false);
        }
        x1 = to1.X;
        y1 = to1.Y;
        used[x1 + n][y1 + n] = 1;
    }

    // ans = max(ans, cnt_moves);
    // cout << cnt_moves << endl;
}

void solve() {
    int T;
    cin >> T >> n;
    int cnt_cells = 0;
    for (int i = -n; i <= n; ++i) {
        for (int j = -n; j <= n; ++j) {
            if (can(i, j)) {
                ++cnt_cells;
            }
        }
    }
    // cout << "cnt_cells = " << cnt_cells << endl;
    ans = 0;
    for (int numt = 0; numt < T; ++numt) {
        // cout << numt << ": ";
        play();
    }
    // cout << ans << endl;
}

signed main() {
#ifdef LOCAL
    // assert(freopen("input.txt", "r", stdin));
    // assert(freopen("output.txt", "w", stdout));
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);

    int T = 1;
    // cin >> T;
    for (int numt = 0; numt < T; ++numt) {
        solve();
    }

#ifdef LOCAL
    cout << endl << endl << "time = " << clock() / (double)CLOCKS_PER_SEC << endl;
#endif
}


