#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 1000 + 228;
const ld eps = 1e-9;

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        a -= MOD;
    }
    return a;
}

int sub(int a, int b) {
    a -= b;
    if (a < 0) {
        a += MOD;
    }
    return a;
}

int mul(int a, int b) {
    return ((ll)a * b) % MOD;
}

int pw(int x, int n) {
    int ans = 1;
    while (n) {
        if (n & 1) {
            ans = mul(ans, x);
        }
        x = mul(x, x);
        n >>= 1;
    }

    return ans;
}

struct point {
    ll x;
    ll y;
};

point arr[MAX_N];
int fc[MAX_N];
int ifc[MAX_N];
vector<ld> at_hui[MAX_N];
ll at_l[MAX_N];
ll at_r[MAX_N];
ll rl_l[MAX_N];
ll rl_r[MAX_N];
bool alive[MAX_N];

int cnk(int n, int k) {
    if (n < 0 || k < 0 || k > n) {
        return 0;
    }
    return mul(mul(fc[n], ifc[k]), ifc[n - k]);
}

void move_up(int& ans, int& l, int& r, int n) {
    ans = mul(ans, 2);
    ans = add(ans, cnk(n - 1, l - 1));
    ans = sub(ans, cnk(n - 1, r));

    /*ans = 0;
    for (int i = l; i <= r; ++i) {
        ans = add(ans, cnk(n, i));
    }*/
}

void move_to(int& ans, int& l, int& r, int n, int to_l, int to_r) {
    while (r < to_r) {
        ans = add(ans, cnk(n, ++r));
    }
    while (to_l < l) {
        ans = add(ans, cnk(n, --l));
    }
    while (l < to_l) {
        ans = sub(ans, cnk(n, l++));
    }
    while (to_r < r) {
        ans = sub(ans, cnk(n, r--));
    }
}
/*
typedef __int128_t i228;

i228 gcd(i228 a, i228 b) {
    return (b == 0) ? a : gcd(b, a % b);
}

struct zalupa {
    __int128_t x = 0;
    __int128_t y = 1;

    void nr() {
        i228 gc = gcd(x, y);
        x /= gc;
        y /= gc;
    }

    zalupa operator*(zalupa& other) {
        zalupa ans;
        ans.x = x * other.x;
        ans.y = y * other.y;
        ans.nr();
        return ans;
    }

    zalupa operator/(zalupa& other) {
        zalupa ans;
        ans.x = x * other.y;
        ans.y = y * other.x;
    }
};
*/

point operator-(const point& a, const point& b) {
    return {a.x - b.x, a.y - b.y};
}

bool operator*(const point& a, const point& b) {
    return a.x * b.y - a.y * b.x;
}

bool in_tr(point a) {
    ll s = abs((arr[2] - arr[0]) * (arr[1] - arr[0]));
    ll sm = 0;
    for (int i = 0; i < 3; ++i) {
        sm += abs((arr[i] - a) * (arr[(i + 1) % 3] - a));
    }

    return s == sm;
}

void solve() {
    for (int i = 0; i < 3; ++i) {
        cin >> arr[i].x >> arr[i].y;
    }

    for (int i = 0; i < MAX_N; ++i) {
        alive[i] = false;
        at_hui[i].clear();
    }

    for (int i = 0; i < 3; ++i) {
        point fr = arr[i];
        point sc = arr[(i + 1) % 3];

        if (fr.y == sc.y) {
            if (fr.y >= 0) {
                at_hui[fr.y].push_back(fr.x);
                at_hui[fr.y].push_back(sc.x);
            }
        } else {
            if (fr.y > sc.y) {
                swap(fr, sc);
            }
            ll dx = sc.x - fr.x;

            for (ll i = max(0ll, fr.y); i <= sc.y; ++i) {
                ld cur_x = fr.x + (ld)dx * ((i - fr.y) / ld(sc.y - fr.y));
                at_hui[i].push_back(cur_x);
            }
        }
    }

    for (int i = 0; i < MAX_N; ++i) {
        if (at_hui[i].size() > 0) {
            sort(at_hui[i].begin(), at_hui[i].end());
            vector<ld> new_hui;
            for (auto x : at_hui[i]) {
                if (new_hui.empty() || abs(x - new_hui.back()) > eps) {
                    new_hui.push_back(x);
                }
            }

            if ((int)new_hui.size() == 1) {
                alive[i] = true;
                at_l[i] = at_r[i] = roundl(new_hui[0]);
            } else {
                assert(new_hui.size() == 2);
                alive[i] = true;
                at_l[i] = ceill(new_hui[0]);
                at_r[i] = floorl(new_hui[1]);
            }

            while (at_l[i] > -i && in_tr({at_l[i] - 1, i})) {
                --at_l[i];
            }
            while (at_r[i] < i && in_tr({at_r[i] + 1, i})) {
                ++at_r[i];
            }

            at_l[i] = max(at_l[i], (ll)-i);
            at_r[i] = min(at_r[i], (ll)i);

            at_l[i] += i;
            at_r[i] += i;

            rl_l[i] = (at_l[i] + 1) / 2;
            rl_r[i] = at_r[i] / 2;
        }
    }

    int ans = 0;
    int cur_ans = 1;
    int cur_l = 0;
    int cur_r = 0;
    for (int i = 0; i < MAX_N - 1; ++i) {
        if (alive[i] && rl_l[i] <= rl_r[i]) {
            move_to(cur_ans, cur_l, cur_r, i, rl_l[i], rl_r[i]);
            ans = add(ans, cur_ans);
        }
        move_up(cur_ans, cur_l, cur_r, i + 1);
    }

    printf("%d\n", ans);
}

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    fc[0] = 1;
    ifc[0] = 1;
    for (int i = 1; i < MAX_N; ++i) {
        fc[i] = mul(fc[i - 1], i);
        ifc[i] = pw(fc[i], MOD - 2);
    }

    int t;
    scanf("%d", &t);
    while (t--) {
        solve();
    }

    return 0;
}

