/*
* C++11 code template for contests.
* @author: Andrei Kalendarov
* @e-mail: andreykalendarov@gmail.com
*/

//#define ANDREIKKAA_ALLOCATOR
const int _ML = 450;

const char _inpf[] =
#if defined(ANDREIKKAA)
        "input.txt"
#else
""
#endif
;
const char _outf[] =
#if defined(ANDREIKKAA)
        ""
#else
""
#endif
;

#if defined(ANDREIKKAA)
#undef NDEBUG
#else
#pragma GCC optimize("O3,no-stack-protector")
#endif
#include "bits/stdc++.h"
#if !defined(ANDREIKKAA)
#define endl '\n'
#endif
#define x first
#define y second
using namespace std;
#define rand abcdefghijklmnopqrstuvwxyz
#define random_shuffle abcdefghijklmnopqrstuvwxyz
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
using ll = long long;
using ld = long double;
const ld PI = 3.14159265358979323846;
mt19937 rd(228);
#if defined(ANDREIKKAA_ALLOCATOR)
char _mem[_ML * 1024 * 1024];
size_t _ptr = 0;
inline void* operator new (size_t _x) { _ptr += _x; if(_ptr >= _ML * 1024 * 1024) {_ptr = 12345;} return _mem + _ptr - _x; }
inline void operator delete (void*) { }
#endif
template<class T, class U> inline ostream &operator<< (ostream &, const pair<T, U> &);
template<class T, class U> inline istream &operator>> (istream &, pair<T, U> &);
template<class T> inline ostream &operator<< (ostream &, const vector<T> &);
template<class T> inline istream &operator>> (istream &, vector<T> &);
template<class T> inline ostream &operator<< (ostream &, const set<T> &);
template<class T> inline ostream &operator<< (ostream &, const multiset<T> &);
template<class T> inline ostream &operator<< (ostream &, const unordered_set<T> &);
template<class T> inline ostream &operator<< (ostream &, const unordered_multiset<T> &);
template<class T, class U> inline ostream &operator<< (ostream &, const map<T, U> &);
template<class T, class U> inline ostream &operator<< (ostream &, const unordered_map<T, U> &);

/* ________ CODE ________ */


const int N = 600'228;
struct node {
    int val;
    int mn;
    int mx;
    int l, r;
};
node t[N / 3];


using snode = vector<int>;
snode tbyl[4 * N], tbyr[4 * N];

void f(int v) {
    assert(v);

    t[v].mn = t[v].mx = t[v].val;

    if(t[v].l) {
        f(t[v].l);
        t[v].mn = t[t[v].l].mn;
    }

    if(t[v].r) {
        f(t[v].r);
        t[v].mx = t[t[v].r].mx;
    }
}

void upd_t(snode t[4 * N], int v, int l, int r, const int P, const int X) {
    if(P < l || r <= P) {
        return;
    }

    t[v].push_back(X);

    if(r - l == 1) {
        return;
    }

    upd_t(t, v << 1, l, (l + r) >> 1, P, X);
    upd_t(t, v << 1 | 1, (l + r) >> 1, r, P, X);
}

void fix_t(snode t[4 * N], int v, int l, int r) {
    if(t[v].empty()) {
        return;
    }

    sort(all(t[v]));

    if(r - l == 1) {
        return;
    }

    fix_t(t, v << 1, l, (l + r) >> 1);
    fix_t(t, v << 1 | 1, (l + r) >> 1, r);
}

int get_ls_t(snode t[4 * N], int v, int l, int r, int L, int R) {
    if(R <= l || r <= L) {
        return 0;
    }

    if(L <= l && r <= R) {
        return lower_bound(all(t[v]), L) - t[v].begin();
    }

    return get_ls_t(t, v << 1, l, (l + r) >> 1, L, R) + get_ls_t(t, v << 1 | 1, (l + r) >> 1, r, L, R);
}

int get_greq_t(snode t[4 * N], int v, int l, int r, int L, int R) {
    if(R <= l || r <= L) {
        return 0;
    }

    if(L <= l && r <= R) {
        return t[v].end() - lower_bound(all(t[v]), R);
    }

    return get_greq_t(t, v << 1, l, (l + r) >> 1, L, R) + get_greq_t(t, v << 1 | 1, (l + r) >> 1, r, L, R);
}


inline void _main_function() {
    int n;
    cin >> n;

    vector<int> c;
    for(int i = 1; i <= n; ++i) {
        cin >> t[i].l >> t[i].r >> t[i].val;
        c.push_back(t[i].val);
    }

    int q;
    cin >> q;

    vector<pair<int, int>> a(q);
    cin >> a;

    for(int i = 0; i < q; ++i) {
        c.push_back(a[i].x);
        c.push_back(a[i].y);
    }

    sort(all(c));
    c.erase(unique(all(c)), c.end());

    for(int i = 1; i <= n; ++i) {
        t[i].val = lower_bound(all(c), t[i].val) - c.begin();
    }

    for(int i = 0; i < q; ++i) {
        a[i].x = lower_bound(all(c), a[i].x) - c.begin();
        a[i].y = lower_bound(all(c), a[i].y) - c.begin();
    }

    f(1);

    for(int i = 1; i <= n; ++i) {
        //cout << t[i].mn << " " << t[i].mx << endl;
        upd_t(tbyr, 1, 0, sz(c), t[i].mx, t[i].mn);
        upd_t(tbyl, 1, 0, sz(c), t[i].mn, t[i].mx);
    }

    fix_t(tbyl, 1, 0, sz(c));
    fix_t(tbyr, 1, 0, sz(c));

    for(auto i : a) {
        const int lft = get_ls_t(tbyr, 1, 0, sz(c), i.x, i.y + 1);
        const int rgt = get_greq_t(tbyl, 1, 0, sz(c), 0, i.y + 1);

        //cout << i << ": " << endl;
        cout << 2 * (lft + rgt) + 1 << endl;
    }
}

/* ________ CODE ________ */

int main() {
#if defined(ANDREIKKAA)
    time_t _start = clock();
#endif
    if (_inpf[0] != '\0') assert(freopen(_inpf, "r", stdin) != nullptr);
    if (_outf[0] != '\0') assert(freopen(_outf, "w", stdout) != nullptr);
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    cout << setprecision(20);
    //cout << fixed;

    _main_function();
#if defined(ANDREIKKAA)
    cout << "Time: " << (clock() - _start) / (ld)CLOCKS_PER_SEC << endl;
#endif
}

template<class T, class U> inline ostream &operator<< (ostream &_out, const pair<T, U> &_p) {
    _out << _p.x << ' ' << _p.y;
    return _out;
}
template<class T, class U> inline istream &operator>> (istream &_in, pair<T, U> &_p) {
    _in >> _p.x >> _p.y;
    return _in;
}
template<class T> inline ostream &operator<< (ostream &_out, const vector<T> &_v) {
    if (_v.empty()) { return _out; }
    _out << *_v.begin();
    for (auto _it = ++_v.begin(); _it != _v.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T> inline istream &operator>> (istream &_in, vector<T> &_v) {
    for (auto &_i : _v) { _in >> _i; }
    return _in;
}
template<class T> inline ostream &operator<< (ostream &_out, const set<T> &_s) {
    if (_s.empty()) { return _out; }
    _out << *_s.begin();
    for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T> inline ostream &operator<< (ostream &_out, const multiset<T> &_s) {
    if (_s.empty()) { return _out; }
    _out << *_s.begin();
    for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T> inline ostream &operator<< (ostream &_out, const unordered_set<T> &_s) {
    if (_s.empty()) { return _out; }
    _out << *_s.begin();
    for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T> inline ostream &operator<< (ostream &_out, const unordered_multiset<T> &_s) {
    if (_s.empty()) { return _out; }
    _out << *_s.begin();
    for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; }
    return _out;
}
template<class T, class U> inline ostream &operator<< (ostream &_out, const map<T, U> &_m) {
    if (_m.empty()) { return _out; }
    _out << '(' << _m.begin()->x << ": " << _m.begin()->y << ')';
    for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) { _out << ", (" << _it->x << ": " << _it->y << ')'; }
    return _out;
}
template<class T, class U> inline ostream &operator<< (ostream &_out, const unordered_map<T, U> &_m) {
    if (_m.empty()) { return _out; }
    _out << '(' << _m.begin()->x << ": " << _m.begin()->y << ')';
    for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) { _out << ", (" << _it->x << ": " << _it->y << ')'; }
    return _out;
}
