#include <bits/stdc++.h>
using namespace std;

string a, b;
map<uint64_t, vector<string>> dict;
map<uint64_t, int> dict_counter;

int main_set[26];
int main_set_size{0};
char all_main_chars[26];

uint64_t string_to_pattern(const char* s, bool* ok) {
        int n_set[26];
        int n_size{main_set_size};
        int n_cnt{main_set_size + 1};
        memcpy(n_set, main_set, sizeof n_set);
        uint64_t h{0};
        for (int i = 0; s[i]; ++i) {
                char c = s[i];
                if (!n_set[c - 'A']) {
                        n_set[c - 'A'] = n_cnt++;
                        ++n_size;
                }
                h = h * 11 + n_set[c - 'A'];
        }
        if (ok && n_size > 10)
                *ok = false;
        return h;
}

void read_input()
{
        memset(main_set, 0, sizeof main_set);
        int cnt{1};
        cin >> a >> b;
        for (char c : a) {
                if (!main_set[c - 'A']) {
                        main_set[c - 'A'] = cnt++;
                        all_main_chars[main_set_size++] = c;
                }
        }
        for (char c : b) {
                if (!main_set[c - 'A']) {
                        main_set[c - 'A'] = cnt++;
                        all_main_chars[main_set_size++] = c;
                }
        }
        int n;
        cin >> n;
        string s;
        while (n--) {
                bool ok{true};
                cin >> s;
                auto h = string_to_pattern(s.c_str(), &ok);
                if (ok)
                        dict[h].push_back(s);
        }
}

unordered_set<uint64_t> used_perms;

inline uint64_t perm_to_int(const array<uint8_t, 10>& perm)
{
       uint64_t x{0};
       for (int i{0}; i < main_set_size; ++i)
               x = x * 10 + perm[i];
       return x;
}

int cur_main_mapping[26];

uint64_t string_to_int(const string& s)
{
        uint64_t res{0};
        for (char c : s)
                res = res * 10 + cur_main_mapping[c - 'A'];
        return res;
}

char rev_mapping[10];

void calc(const array<uint8_t, 10>& perm) {
        memset(rev_mapping, 0, 10);
        memset(cur_main_mapping, -1, sizeof cur_main_mapping);
        for (int i{0}; i < main_set_size; ++i) {
                cur_main_mapping[all_main_chars[i] - 'A'] = perm[i];
                rev_mapping[perm[i]] = all_main_chars[i];
        }
        if (0 == cur_main_mapping[a.front() - 'A'])
                return;
        if (0 == cur_main_mapping[b.front() - 'A'])
                return;
        uint64_t s1 = string_to_int(a), s2 = string_to_int(b);
        char res[16];
        if (snprintf(res, 16, "%lu", s1 + s2) > 15)
                return;
        char new_c{'A'};
        for (char& c : res) {
                if (!c) break;
                if (!rev_mapping[c - '0']) {
                        while (-1 != cur_main_mapping[new_c - 'A'])
                                ++new_c;
                        cur_main_mapping[new_c - 'A'] = c - '0';
                        rev_mapping[c - '0'] = new_c;
                }
                c = rev_mapping[c - '0'];
        }
        bool ok{true};
        auto h = string_to_pattern(res, &ok);
        if (ok && dict.count(h))
                ++dict_counter[h];
}

int main()
{
        //freopen("brainteaser2.in", "r", stdin);
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        read_input();
        array<uint8_t, 10> perm = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
        do {
                auto x = perm_to_int(perm);
                if (!used_perms.count(x)) {
                        used_perms.insert(x);
                        calc(perm);
                }
        } while (next_permutation(perm.begin(), perm.end()));
        vector<string> ans;
        for (auto [h, cnt] : dict_counter) {
                if (1 == cnt)
                        ans.insert(ans.end(), dict[h].begin(), dict[h].end());
        }
        sort(ans.begin(), ans.end());
        cout << ans.size() << '\n';
        for (const auto& word : ans)
                cout << word << '\n';
}
