#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool ok(int x, int y) {
    return abs(x - y) <= 1;
}

pair<int, int> split(int a, int b) {
    if (b % 2 == 0) {
        return {a / 2, b / 2};
    } else {
        int b1 = b / 2;
        if (a <= 2) {
            int a1 = a;
            return {a1, b1};
        } else {
            int a1 = 2 + (a - 2) / 2;
            return {a1, b1};
        }
    }
}

vector<int> w, l, r;

int nn(int weight) {
    w.push_back(weight);
    l.push_back(-1);
    r.push_back(-1);
    return (int) w.size() - 1;
}

int solve(int a, int b) {
    if (a == 0 && b == 0) {
        return -1;
    }

    if (b > 0) {
        int v = nn(2);
        auto kek = split(a, b - 1);
        int a1 = kek.first;
        int b1 = kek.second;
        int a2 = a - kek.first;
        int b2 = b - 1 - kek.second;

        if (!ok(a1 + 2 * b1, a2 + 2 * b2)) {
            cout << -1 << endl;
            exit(0);
        }
        l[v] = solve(a1, b1);
        r[v] = solve(a2, b2);
        return v;
    } else {
        int v = nn(1);
        auto kek = split(a - 1, b);
        int a1 = kek.first;
        int b1 = kek.second;
        int a2 = a - 1 - kek.first;
        int b2 = b - kek.second;

        if (!ok(a1 + 2 * b1, a2 + 2 * b2)) {
            cout << -1 << endl;
            exit(0);
        }
        l[v] = solve(a1, b1);
        r[v] = solve(a2, b2);
        return v;
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int a, b;
    cin >> a >> b;
    solve(a, b);

    for (int i = 0; i < w.size(); ++i) {
        cout << w[i] << " " << l[i] + 1 << " " << r[i] + 1 << "\n";
    }

    return 0;
}
