#pragma GCC optimize("O3")
#include <iostream>
#include <set>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <ctime>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cstring>

using namespace std;

void doRoutine() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(322179);
}

#define DBG(VAR) cerr << #VAR << ": " << VAR << endl

#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define mp make_pair

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define D double
#define int int64_t
#define endl '\n'


template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    //out << "{" << p.fi << ", " << p.se << "}";
    out << p.fi << " " << p.se;
    return out;
}


template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}


template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (int i = 0; i < arr.size(); ++i)
        out << arr[i] << " ";
    out << endl;
    return out;
}


template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (int i = 0; i < arr.size(); ++i)
        in >> arr[i];
    return in;
}

template <typename T>
ostream & operator << (ostream & out, multiset <T> a) {
    out << "{";
    for (auto x : a) {
        out << x << " ";
    }
    out << "}";
    return out;
}


//const int MAX_MEM = 2e8;
//char mem[MAX_MEM];
//int mpos = 0;
//
//inline void* operator new(size_t n) {
//    char *res = mem + mpos;
//    mpos += n;
//    return (void*) res;
//}
//
//inline void operator delete(void*) {}


// ----------------------------- CODE NOW ------------------------

template <typename T>
ostream & operator << (ostream & out, set <T> s) {
    for (auto x : s) {
        out << x << " ";
    }
    out << endl;
    return out;
}

string first;
string second;
unordered_map<string, size_t> counts;
vector<char> all_letters;
map<char, int> cur_digits;
map<int, char> cur_chars;
set<int> possible_digits = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
set<char> all_letters_s;

int64_t str_to_int(const string& str) {
    int64_t result = 0;
    for (auto c : str) {
        result *= 10;
        result += cur_digits[c];
    }
    return result;
}

string int_to_str(int64_t value) {
    string result;
    int id = 0;
    map<int, char> for_digits;
    while (value > 0) {
        int val = value % 10;
        auto it = cur_chars.find(val);
        if (it == cur_chars.end()) {
            result.push_back('0' + val);
        } else {
            result.push_back(it->second);
        }
        value /= 10;
    }
    reverse(result.begin(), result.end());
    return result;
}

string process_string(const string& str_) {
    auto str = str_;
    int id = 0;
    map<int, char> for_digits;
    for (auto& c : str) {
        if (all_letters_s.count(c)) {
            continue;
        }
        auto it = for_digits.find(c);
        if (it == for_digits.end()) {
            auto [it2, _] = for_digits.emplace(c, '0' + id++);
            it = it2;
        }
        c = it->second;
    }
    return str;
}

void brootforce(int k = 0) {
    if (k == all_letters.size()) {
        if (cur_digits[first[0]] == 0 || cur_digits[second[0]] == 0) {
            return;
        }
        counts[process_string(int_to_str(str_to_int(first) + str_to_int(second)))]++;
    } else {
        auto copy = possible_digits;
        for (auto digit : copy) {
            possible_digits.erase(digit);
            cur_digits[all_letters[k]] = digit;
            cur_chars[digit] = all_letters[k];
            brootforce(k + 1);
            cur_chars.erase(digit);
            possible_digits.insert(digit);
        }
    }
}

signed main() {
    doRoutine();
    cin >> first >> second;
    for (auto c : first) {
        all_letters_s.insert(c);
    }
    for (auto c : second) {
        all_letters_s.insert(c);
    }
    if (all_letters.size() > 10) {
        cout << 0 << endl;
        return 0;
    }
    for (auto c : all_letters_s) {
        all_letters.push_back(c);
    }
    brootforce();
    int m;
    cin >> m;
    vector<string> ans;
    for (int i = 0; i < m; ++i) {
        string s;
        cin >> s;
        auto it = counts.find(process_string(s));
        if (it != counts.end() && it->second == 1) {
            ans.push_back(s);
        }
    }
    cout << ans.size() << endl;
    for (const auto& s : ans) {
        cout << s << endl;
    }
    return 0;
}