#pragma GCC optimize("O3")
#include <iostream>
#include <set>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <ctime>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cstring>

using namespace std;

void doRoutine() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define fi first
#define se second
#define endl '\n'

//const int MAX_MEM = 2e9;
//char mem[MAX_MEM];
//int mpos = 0;
//
//inline void* operator new(size_t n) {
//    char *res = mem + mpos;
//    mpos += n;
//    return (void*) res;
//}
//
//inline void operator delete(void*) {}

const int MAXN = 300000 + 10;
const int MAX_BLOCK = 20000;
int n;
uint8_t stairs[MAXN];
int sz[MAXN];
int g[MAXN][8];
uint8_t block_ans[MAX_BLOCK][256 + 10];
int block_start[MAX_BLOCK];
int block_end[MAX_BLOCK];

int count_bits(uint8_t number) {
    int result = 0;
    for (int i = 0; i < 8; ++i) {
        result += (number >> i) & 1;
    }
    return result;
}

void build_g() {
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < std::min(i + 9, n); ++j) {
            if (count_bits(~(stairs[i] ^ stairs[j])) >= j - i) {
                g[i][sz[i]++] = j;
            }
        }
    }
}

uint8_t solve_game(int lb, int rb) {
    vector<bool> win(rb - lb);
    for (int j = rb - 1; j >= lb; --j) {
        for (int i = 0; i < sz[j]; ++i) {
            if (g[j][i] < rb && !win[g[j][i] - lb]) {
                win[j - lb] = true;
                break;
            }
        }
    }
    uint8_t result = 0;
    for (int i = 0; i < 8; ++i) {
        result <<= 1;
        result += (i < win.size() ? win[i] : 0);
    }
    return result;
}


uint8_t solve_game(int lb, int rb, uint8_t next_8) {
    vector<bool> win(rb - lb + 8);
    for (int i = 0; i < 8; ++i) {
        win[rb - lb + i] = (next_8 >> (7 - i)) & 1;
    }
    for (int j = rb - 1; j >= lb; --j) {
        for (int i = 0; i < sz[j]; ++i) {
            if (g[j][i] < n && !win[g[j][i] - lb]) {
                win[j - lb] = true;
                break;
            }
        }
    }
    uint8_t result = 0;
    for (int i = 0; i < 8; ++i) {
        result <<= 1;
        result += win[i];
    }
    return result;
}

signed main() {
    doRoutine();
    memset(sz, 0, sizeof(sz));
    memset(block_ans, 0, sizeof(block_ans));
    memset(stairs, 0, sizeof(stairs));

    cin >> n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 8; ++j) {
            char c;
            cin >> c;
            stairs[i] <<= 1;
            stairs[i] += (c == 'W');
        }
    }
    build_g();
    if (n < 4096) {
        for (int i = 1; i <= n; ++i) {
            auto result = solve_game(0, i);
            cout << (((result >> 7) & 1) ? 1 : 2);
        }
        return 0;
    }
    int block_size = sqrt(n / 8);
    int block_num = (n + block_size - 1) / block_size;
    int id = 0;
    for (int i = 0; i < n; i += block_size) {
        block_start[id] = i;
        block_end[id++] = min(n, i + block_size);
    }
    for (int i = 0; i < block_num; ++i) {
        for (int mask = 0; mask < (1 << 8); ++mask) {
            block_ans[i][mask] = solve_game(block_start[i], block_end[i], mask);
        }
    }
    int nn = n;
    for (n = 1; n <= nn; ++n) {
        int max_block = max(0, (n - 8) / block_size) - 1;
        if (max_block == -1) {
            auto result = solve_game(0, n);
            cout << (((result >> 7) & 1) ? 1 : 2);
        } else {
            auto cur_res = solve_game(block_end[max_block], n);
            for (int block = max_block; block >= 0; --block) {
                cur_res = block_ans[block][cur_res];
            }
            cout << (((cur_res >> 7) & 1) ? 1 : 2);
        }
    }
    return 0;
}