#include<bits/stdc++.h>
using namespace std;

void doRoutine() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(322179);
#ifdef LOCAL
    freopen("/home/max/alg/clion_main/input.txt", "rt", stdin);
    freopen("/home/max/alg/clion_main/output.txt", "wt", stdout);
#endif
}

#define DBG(VAR) cerr << #VAR << ": " << VAR << endl

#define all(x) x.begin(), x.end()
#define vb vector<bool>
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define pll pair<ll, ll>
#define fi first
#define se second
#define pb push_back
#define vc vector
#define $ make_pair

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define D double
#define CD complex<D>
#define ll long long
#define pll pair<ll, ll>
#define pii pll
#define ull unsigned long long


// ----------------------------- CODE NOW ------------------------

const ll MOD = 1000000007;

const ll MAXC = 4000009;

ll fact[MAXC];

ll mod_add(ll a, ll b) {
    return ((ll)a + b) % MOD;
}

ll mod_sub(ll a, ll b) {
    return ((ll)a - (ll)b + MOD) % MOD;
}

ll mod_mul(ll a, ll b) {
    return ((ll)a * b) % MOD;
}

ll get_fact(ll n) {
    return fact[n];
}

ll fpow(ll a, ll n) {
    if (n == 0) {
        return 1;
    }
    else if (n % 2 == 1) {
        return mod_mul(a, fpow(a, n - 1));
    }
    else {
        return fpow(mod_mul(a, a), n / 2);
    }
}

ll rev(ll a) {
    return fpow(a, MOD - 2);
}

ll getC(ll n, ll k) {
    return mod_mul(get_fact(n), rev(mod_mul(get_fact(k), get_fact(n - k))));
}


ll eval(ll a, ll b, ll c, pii pt) {
    return a * pt.fi + b * pt.se + c;
}

bool llersect(pii p1, pii p2, ll d, pll &x_in) {
    ll e1 = eval(-1, 1, -d, p1);
    ll e2 = eval(-1, 1, -d, p2);
    if (e1 > 0 && e2 > 0 || e1 < 0 && e2 < 0) {
        return false;
    }

    ll dx = p2.fi - p1.fi;
    ll dy = p2.se - p1.se;
    if (dx == dy) {
        // collinear
        return false;
    }

    ll a = dy;
    ll b = -dx;
    ll c = -(a * p1.fi + b * p1.se);

    x_in.fi = -(c + b * d); // 8 * 10 ** 12
    x_in.se = a + b; // 4 * 10 ** 6
    if (x_in.se < 0) {
        x_in.fi *= -1;
        x_in.se *= -1;
    }

    return true;
}

ll up(pll num) {
    ll a = num.fi;
    ll b = num.se;
    // b > 0
    if (a >= 0) {
        if (a % b == 0) {
            return a / b;
        }
        else {
            return a / b + 1;
        }
    }
    else {
        ll m = abs(a);
        if (m % b == 0) {
            return -(m / b);
        }
        else {
            return -(m / b);
        }
    }
}

ll down(pll num) {
    ll a = num.fi;
    ll b = num.se;
    // b > 0
    if (a >= 0) {
        if (a % b == 0) {
            return a / b;
        }
        else {
            return a / b ;
        }
    }
    else {
        ll m = abs(a);
        if (m % b == 0) {
            return -(m / b);
        }
        else {
            return -(m / b) - 1;
        }
    }
}


ll getpref(ll k, ll len) {
    if (len == 0) {
        return 0;
    }
    return getC(len + k, k + 1);
}


void solve() {
    vc<pii> tr(3);
    for (ll i = 0; i < 3; ++i) {
        cin >> tr[i].first >> tr[i].second;
    }
    ll C = 1000005;
    ll sum = 0;
    for (ll d = 0; d < 2 * C; d += 2) {
        // line (t, t + d)
        vc<pll> polls_xs;
        for (ll i = 0; i < 3; ++i) {
            pii p1 = tr[i];
            pii p2 = tr[(i + 1) % 3];
            pll x_in;
            bool llersects = llersect(p1, p2, d, x_in);
            if (llersects) {
                polls_xs.pb(x_in);
            }
        }
        if (polls_xs.size() == 2) {
            // llersection exists
            pll x1 = polls_xs[0];
            pll x2 = polls_xs[1];
            if ((__int128_t)x1.fi * (__int128_t)x2.se > (__int128_t)x2.fi * (__int128_t)x1.se) {
                swap(x1, x2);
            }

            // (x1, x2) is the segment of x that line + triangle give
            ll x_from = (ll)up(x1);
            ll x_to = (ll)down(x2);
            x_from = max(x_from, -d / 2);
            if (x_from <= x_to) {
                ll v1 = getpref(d / 2, x_to + d / 2 + 1);
                ll v2 = getpref(d / 2, x_from + d / 2);
                sum = mod_add(sum, mod_sub(v1, v2));
            }
        }
    }
    cout << sum << endl;
}


signed main() {
    doRoutine();

    fact[0] = 1;
    for (ll i = 1; i < MAXC; ++i) {
        fact[i] = mod_mul(fact[i - 1], i);
    }

    ll t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}