#include<bits/stdc++.h>
using namespace std;

void doRoutine() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(322179);
#ifdef LOCAL
    freopen("/home/max/alg/clion_main/input.txt", "rt", stdin);
    freopen("/home/max/alg/clion_main/output.txt", "wt", stdout);
#endif
}


template <typename T>
ostream &operator<<(ostream &out, vector<T> a) {
    out << "[";
    for (int i = 0; i + 1 < a.size(); ++i) {
        out << a[i] << ", ";
    }
    if (!a.empty()) {
        out << a.back();
    }
    out << "]";
    return out;
}

template <typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> a) {
    out << "{" << a.first << ", " << a.second << "}";
    return out;
}


#define DBG(VAR) cerr << #VAR << ": " << VAR << endl

#define all(x) x.begin(), x.end()
#define vb vector<bool>
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fi first
#define se second
#define pb push_back
#define vc vector
#define $ make_pair

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define D double
#define CD complex<D>
#define ll long long
#define pll pair<ll, ll>
#define ull unsigned long long


// ----------------------------- CODE NOW ------------------------

const int MOD = 1000000007;

const int MAXC = 4000009;

int fact[MAXC];

int mod_add(int a, int b) {
    return ((ll)a + b) % MOD;
}

int mod_sub(int a, int b) {
    return ((ll)a - (ll)b + MOD) % MOD;
}

int mod_mul(int a, int b) {
    return ((ll)a * b) % MOD;
}

int get_fact(int n) {
    return fact[n];
}

int fpow(int a, int n) {
    if (n == 0) {
        return 1;
    }
    else if (n % 2 == 1) {
        return mod_mul(a, fpow(a, n - 1));
    }
    else {
        return fpow(mod_mul(a, a), n / 2);
    }
}

int rev(int a) {
    return fpow(a, MOD - 2);
}

int getC(int n, int k) {
    return mod_mul(get_fact(n), rev(mod_mul(get_fact(k), get_fact(n - k))));
}


ll eval(ll a, ll b, ll c, pii pt) {
    return a * pt.fi + b * pt.se + c;
}

bool intersect(pii p1, pii p2, int d, pll &x_in) {
    ll e1 = eval(-1, 1, -d, p1);
    ll e2 = eval(-1, 1, -d, p2);
    if (e1 > 0 && e2 > 0 || e1 < 0 && e2 < 0) {
        return false;
    }

    int dx = p2.fi - p1.fi;
    int dy = p2.se - p1.se;
    if (dx == dy) {
        // collinear
        return false;
    }

    ll a = dy;
    ll b = -dx;
    ll c = -(a * p1.fi + b * p1.se);

    x_in.fi = -(c + b * d); // 8 * 10 ** 12
    x_in.se = a + b; // 4 * 10 ** 6
    if (x_in.se < 0) {
        x_in.fi *= -1;
        x_in.se *= -1;
    }

    return true;
}

ll up(pll num) {
    ll a = num.fi;
    ll b = num.se;
    // b > 0
    if (a >= 0) {
        if (a % b == 0) {
            return a / b;
        }
        else {
            return a / b + 1;
        }
    }
    else {
        ll m = abs(a);
        if (m % b == 0) {
            return -(m / b);
        }
        else {
            return -(m / b);
        }
    }
}

ll down(pll num) {
    ll a = num.fi;
    ll b = num.se;
    // b > 0
    if (a >= 0) {
        if (a % b == 0) {
            return a / b;
        }
        else {
            return a / b ;
        }
    }
    else {
        ll m = abs(a);
        if (m % b == 0) {
            return -(m / b);
        }
        else {
            return -(m / b) - 1;
        }
    }
}


int getpref(int k, int len) {
    if (len == 0) {
        return 0;
    }
    return getC(len + k, k + 1);
}


void solve() {
    vc<pii> tr(3);
    for (int i = 0; i < 3; ++i) {
        cin >> tr[i].first >> tr[i].second;
    }
    int C = 1000005;
    int sum = 0;
    for (int d = 0; d < 2 * C; d += 2) {
        // line (t, t + d)
        vc<pll> points_xs;
        for (int i = 0; i < 3; ++i) {
            pii p1 = tr[i];
            pii p2 = tr[(i + 1) % 3];
            pll x_in;
            bool intersects = intersect(p1, p2, d, x_in);
            if (intersects) {
                points_xs.pb(x_in);
            }
        }
        if (!points_xs.empty()) {
            // intersection exists
            // 2 or 3 xs
            pll x1 = points_xs[0];
            pll x2 = points_xs[1];
            if (points_xs.size() == 3) {
                pll x3 = points_xs[2];
                if ((__int128_t)x1.fi * (__int128_t)x2.se == (__int128_t)x2.fi * (__int128_t)x1.se) {
                    x2 = x3;
                }
            }
            if ((__int128_t)x1.fi * (__int128_t)x2.se > (__int128_t)x2.fi * (__int128_t)x1.se) {
                swap(x1, x2);
            }

            // (x1, x2) is the segment of x that line + triangle give
            int x_from = (int)up(x1);
            int x_to = (int)down(x2);
            x_from = max(x_from, -d / 2);
            if (x_from <= x_to) {
                int v1 = getpref(d / 2, x_to + d / 2 + 1);
                int v2 = getpref(d / 2, x_from + d / 2);
                sum = mod_add(sum, mod_sub(v1, v2));
            }
        }
    }
    cout << sum << endl;
}


signed main() {
    doRoutine();

    fact[0] = 1;
    for (int i = 1; i < MAXC; ++i) {
        fact[i] = mod_mul(fact[i - 1], i);
    }

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}