#!/usr/bin/env python
# coding: utf-8

# In[13]:


# ll gcd (ll a, ll b, ll & x, ll & y) {
#     if (a == 0) {
#         x = 0; y = 1;
#         return b;
#     }
#     ll x1, y1;
#     ll d = gcd (b % a, a, x1, y1);
#     x = y1 - (b / a) * x1;
#     y = x1;
#     return d;
# }

def gcd(a, b):
    if a == 0:
        return b, 0, 1

    g, x1, y1 = gcd(b % a, a)
    return g, y1 - (b // a) * x1, x1

# gcd(2, 7)





# bool find_any_solution (ll a, ll b, ll c, ll & x0, ll & y0, ll & g) {
#     g = gcd (abs(a), abs(b), x0, y0);
#     if (c % g != 0)
#         return false;
#     x0 *= c / g;
#     y0 *= c / g;
#     if (a < 0)   x0 *= -1;
#     if (b < 0)   y0 *= -1;
#     return true;
# }

def find_any_solution(a, b, c):
    g, x0, y0 = gcd(abs(a), abs(b))
    if c % g != 0:
        return

    x0 *= c // g
    y0 *= c // g

    if a < 0:
        x0 *= -1
    if b < 0:
        y0 *= -1

    return g, x0, y0

# find_any_solution(1, 3, 6)









# void shift_solution (ll & x, ll & y, ll a, ll b, ll cnt) {
#     x += cnt * b;
#     y -= cnt * a;
# }

def shift_solution(x, y, a, b, cnt):
    x += cnt * b;
    y -= cnt * a;
    return x, y







# ll find_all_solutions (ll a, ll b, ll c, ll minx, ll maxx, ll miny, ll maxy) {
#     ll x, y, g;
#     if (! find_any_solution (a, b, c, x, y, g))
#         return 0;
#     a /= g;  b /= g;

#     ll sign_a = a>0 ? +1 : -1;
#     ll sign_b = b>0 ? +1 : -1;

#     shift_solution (x, y, a, b, (minx - x) / b);
#     if (x < minx)
#         shift_solution (x, y, a, b, sign_b);
#     if (x > maxx)
#         return 0;
#     ll lx1 = x;

#     shift_solution (x, y, a, b, (maxx - x) / b);
#     if (x > maxx)
#         shift_solution (x, y, a, b, -sign_b);
#     ll rx1 = x;

#     shift_solution (x, y, a, b, - (miny - y) / a);
#     if (y < miny)
#         shift_solution (x, y, a, b, -sign_a);
#     if (y > maxy)
#         return 0;
#     ll lx2 = x;

#     shift_solution (x, y, a, b, - (maxy - y) / a);
#     if (y > maxy)
#         shift_solution (x, y, a, b, sign_a);
#     ll rx2 = x;

#     if (lx2 > rx2)
#         swap (lx2, rx2);
#     ll lx = max (lx1, lx2);
#     ll rx = min (rx1, rx2);

#     return (rx - lx) / abs(b) + 1;
# }

def find_all_solutions(a, b, c, minx, maxx, miny, maxy):
#     ll x, y, g;
    if find_any_solution(a, b, c) is None:
#     if (! find_any_solution (a, b, c, x, y, g))
        return 0

    g, x, y = find_any_solution(a, b, c)

    a //= g;  b //= g;

    sign_a = +1 if a>0 else -1
    sign_b = +1 if b>0 else -1

    x, y = shift_solution (x, y, a, b, (minx - x) // b)
    if (x < minx):
        x, y = shift_solution (x, y, a, b, sign_b)
    if (x > maxx):
        return 0
    lx1 = x;

    x, y = shift_solution (x, y, a, b, (maxx - x) // b)
    if (x > maxx):
        x, y = shift_solution (x, y, a, b, -sign_b)
    rx1 = x

    x, y = shift_solution (x, y, a, b, - (miny - y) // a)
    if (y < miny):
        x, y = shift_solution (x, y, a, b, -sign_a)
    if (y > maxy):
        return 0
    lx2 = x

    x, y = shift_solution (x, y, a, b, - (maxy - y) // a);
    if (y > maxy):
        x, y = shift_solution (x, y, a, b, sign_a);
    rx2 = x

    if (lx2 > rx2):
        lx2, rx2 = rx2, lx2;
    lx = max (lx1, lx2);
    rx = min (rx1, rx2);

    return (rx - lx) // abs(b) + 1




n = int(input())
for i in range(n):
    b, d = map(int, input().split())
    ans = find_all_solutions(d, b, b * b, 1, 10 ** 18 + 100, 1, 10 ** 18 + 1000)
    print(ans)


# In[ ]:





# In[ ]:





# In[ ]:




