#include <bits/stdc++.h>
using namespace std;

// answer is 1 + 2 * {# of nodes that branch out}

const int inf = 1e9;

struct Node {
    int key, prior, size = 1, count = 1;
    Node *l = 0, *r = 0;
    Node (int _key) { key = _key, prior = rand(); }
};

int size (Node *v) { return v ? v->size : 0; }

void upd (Node *v) { v->size = v->count + size(v->l) + size(v->r); }

Node* merge (Node *l, Node *r) {
    if (!l) return r;
    if (!r) return l;
    if (l->prior > r->prior) {
        l->r = merge(l->r, r);
        upd(l);
        return l;
    }
    else {
        r->l = merge(l, r->l);
        upd(r);
        return r;
    }
}

typedef pair<Node*, Node*> Pair;

Pair split (Node *p, int x) {
    if (!p) return {0, 0};
    if (p->key <= x) {
        Pair q = split(p->r, x);
        p->r = q.first;
        upd(p);
        return {p, q.second};
    }
    else {
        Pair q = split(p->l, x);
        p->l = q.second;
        upd(p);
        return {q.first, p};
    }
}

Node *root = 0;

void insert (int x) {
    Pair rq = split(root, x);
    Pair lq = split(rq.first, x-1);
    if (lq.second) {
        lq.second->count += 1;
        upd(lq.second);
    } else {
        lq.second = new Node(x);
    }
    root = merge(lq.first, merge(lq.second, rq.second));
}

int get_sum (int l, int r) {
    //cerr << "g " << size(root) << endl;
    Pair rq = split(root, r);
    Pair lq = split(rq.first, l - 1);
    int res = size(lq.second);
    //cerr << "r " << l << " " << r << " " << res << endl;
    root = merge(lq.first, merge(lq.second, rq.second));
    return res;
}

const int maxn = 2e5 + 5;
int l[maxn], r[maxn], k[maxn];
int _l[maxn], _r[maxn];
int results[maxn];

set<int> xs;
map<int, vector<int>> adds;

struct Query {
    int L, R;
    int result_idx;
};

map<int, vector<Query>> queries;

void add_query(int x, Query q) {
    xs.insert(x);
    queries[x].push_back(q);
}

void build_events(int v) {
    if (v == 0)
        return;
    build_events(l[v]);
    build_events(r[v]);
    _l[v] = min(k[v], _l[l[v]]);
    _r[v] = max(k[v], _r[r[v]]);
    xs.insert(_l[v]);
    adds[_l[v]].push_back(_r[v]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i] >> k[i];
    
    _l[0] = inf;
    _r[0] = -inf;
    build_events(1);

    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        int L, R;
        cin >> L >> R;
        // everything, except:
        // v.max < L                  y < L
        // v.min > R                  x > R
        // L <= v.min && v.max <= R   L <= x, y <= R
        add_query(L - 1, {L, R, i});
        add_query(R, {R + 1, inf, i});
        /*
        add_query(-inf, {-inf, L - 1, i});
        results[i] = n;
        add_query(R, {-inf, inf, i, -1});
        add_query();
        */
    }

    /*
    for (int x : xs) {
        for (int y : adds[x]) {
            cerr << x << " " << y << endl;
        }
    }
    */

    for (int x : xs) {
        //cerr << "x " << x << endl;
        for (int y : adds[x]) {
            //cerr << "add " << y << endl;
            insert(y);
        }
        for (auto q : queries[x]) {
            int res = get_sum(q.L, q.R);
            //cerr << "q " << q.L << " " << q.R << " " << q.result_idx << " " << res << endl;
            results[q.result_idx] += res;
        }
    }
    
    for (int i = 0; i < q; i++)
        cout << 1 + 2 * results[i] << "\n";

    return 0;
}
