#include <iostream>
#include <string>
#include <algorithm>
#include <sstream>
#include <vector>
#include <deque>
#include <queue>
#include <math.h>

using namespace std;

struct Node{
	int weight = 1;
	int weight_subtree = 1;
	int disbalances = 0;
	int id = 0;
	Node* left = nullptr;
	Node* right = nullptr;
	Node* parent = nullptr;
	Node() {
	}
	Node(int _weight, int _id) {
		weight_subtree = _weight;
		weight = _weight;
		id = _id;
	}
};

struct Tree {
	Node* root = nullptr;
	int ids = 1;

	Tree() {
	}

	int weight_subtree(Node* node) {
		if (!node)
			return 0;
		return node->weight_subtree;
	}

	int disbalances(Node* node) {
		if (!node)
			return 0;
		return node->disbalances;
	}

	void insert_recursive(Node* node, int w) {
		node->weight_subtree += w;
		int w_l = weight_subtree(node->left);
		int w_r = weight_subtree(node->right);
		if (w_l < w_r) {
			if (node->left)
				insert_recursive(node->left, w);
			else
				node->left = new Node(w, ids++);
		}
		else if (w_l > w_r) {
			if (node->right)
				insert_recursive(node->right, w);
			else
				node->right = new Node(w, ids++);
		} 
		else {
			int d_l = disbalances(node->left);
			int d_r = disbalances(node->right);
			if (d_l > d_r) {
				if (node->left)
					insert_recursive(node->left, w);
				else
					node->left = new Node(w, ids++);
			}
			else {
				if (node->right)
					insert_recursive(node->right, w);
				else
					node->right = new Node(w, ids++);
			}
		}
		node->disbalances = disbalances(node->left) + disbalances(node->right);
		if (abs(weight_subtree(node->left) - weight_subtree(node->right)) > 1)
			node->disbalances++;
	}

	void insert(int w) {
		if (!root) {
			root = new Node(w, ids++);
			return;
		}
		insert_recursive(root, w);
	}

	int get_id(Node* node) {
		if (!node)
			return 0;
		return node->id;
	}

	void enumerate(Node* node) {
		if (!node)
			return;
		node->id = ids++;
		enumerate(node->left);
		enumerate(node->right);
	}

	void print(Node* node) {
		if (!node)
			return;
		cout << node->weight << " " << get_id(node->left) << " " << get_id(node->right) << "\n";
		print(node->left);
		print(node->right);
	}

};

int main() {
	int n, m;
	cin >> n >> m;

	Tree tree;

	for (int i = 0; i < m; i++)
		tree.insert(2);
	for (int i = 0; i < n; i++)
		tree.insert(1);


	if (tree.root->disbalances) {
		cout << -1;
		return 0;
	}

	tree.ids = 1;
	tree.enumerate(tree.root);
	tree.print(tree.root);
}