#include <iostream>
#include <string>
#include <algorithm>
#include <sstream>
#include <vector>
#include <deque>
#include <queue>
#include <math.h>

#define INF 1000000

using namespace std;

struct Node {
	int val = 0;
	int count = 0;
	int min = INF;
	int max = -INF;
	int left = 0;
	int right = 0;
};

struct Tree {
	vector<Node> nodes;
	int counter = 0;

	int get_count(int index) {
		if (!index)
			return 0;
		return nodes[index - 1].count;
	}

	int get_min(int index) {
		if (!index)
			return INF;
		return nodes[index - 1].min;
	}

	int get_max(int index) {
		if (!index)
			return -INF;
		return nodes[index - 1].max;
	}

	void init(int index) {
		if (!index)
			return;
		index--;
		init(nodes[index].left);
		init(nodes[index].right);
		nodes[index].count = get_count(nodes[index].left) + get_count(nodes[index].right) + 1;
		nodes[index].min = min(min(get_min(nodes[index].left), get_min(nodes[index].right)), nodes[index].val);
		nodes[index].max = max(max(get_max(nodes[index].left), get_max(nodes[index].right)), nodes[index].val);
	}

	int lookup(int index, int L, int R) {
		//cout << "LOOKUP " << index << " " << L << " " << R << "\n";
		counter++;
		if (!index)
			return 0;
		index--;
		if (L <= nodes[index].min && nodes[index].max <= R)
			return nodes[index].count;
		if (nodes[index].max < L || R < nodes[index].min)
			return 0;
		int res = 0;
		if (L <= nodes[index].val && nodes[index].val <= R)
			res += 1;
		res += lookup(nodes[index].left, L, R);
		res += lookup(nodes[index].right, L, R);
		return res;
	}


};

int main() {
	int n;
	cin >> n;
	Tree tree;
	tree.nodes = vector<Node>(n);

	for (Node& node : tree.nodes)
		cin >>  node.left >> node.right >> node.val;
	tree.init(1);

	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		tree.counter = 0;
		int a, b;
		cin >> a >> b;
		tree.lookup(1, a, b);
		cout << tree.counter << "\n";
	}
}