#include <iostream>
#include <string>
#include <algorithm>
#include <sstream>
#include <vector>
#include <deque>
#include <queue>
#include <math.h>

#define INF 1000000000

using namespace std;

struct Node {
	long long val = 0;
	long long count = 0;
	long long min = INF;
	long long max = -INF;
	long long left = 0;
	long long right = 0;
};

struct Tree {
	vector<Node> nodes;
	long long counter = 0;

	long long get_count(long long index) {
		if (!index)
			return 0;
		return nodes[index - 1].count;
	}

	long long get_min(long long index) {
		if (!index)
			return INF;
		return nodes[index - 1].min;
	}

	long long get_max(long long index) {
		if (!index)
			return -INF;
		return nodes[index - 1].max;
	}

	void init(long long index) {
		if (!index)
			return;
		index--;
		init(nodes[index].left);
		init(nodes[index].right);
		nodes[index].count = get_count(nodes[index].left) + get_count(nodes[index].right) + 1;
		nodes[index].min = min(min(get_min(nodes[index].left), get_min(nodes[index].right)), nodes[index].val);
		nodes[index].max = max(max(get_max(nodes[index].left), get_max(nodes[index].right)), nodes[index].val);
	}

	long long lookup(long long index, long long L, long long R) {
		//cout << "LOOKUP " << index << " " << L << " " << R << "\n";
		counter++;
		if (!index)
			return 0;
		index--;
		if (L <= nodes[index].min && nodes[index].max <= R)
			return nodes[index].count;
		if (nodes[index].max < L || R < nodes[index].min)
			return 0;
		long long res = 0;
		if (L <= nodes[index].val && nodes[index].val <= R)
			res += 1;
		res += lookup(nodes[index].left, L, R);
		res += lookup(nodes[index].right, L, R);
		return res;
	}


};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	long long n;
	cin >> n;
	Tree tree;
	tree.nodes = vector<Node>(n);

	for (Node& node : tree.nodes)
		cin >>  node.left >> node.right >> node.val;
	tree.init(1);

	long long m;
	cin >> m;
	for (long long i = 0; i < m; i++) {
		tree.counter = 0;
		long long a, b;
		cin >> a >> b;
		tree.lookup(1, a, b);
		cout << tree.counter << "\n";
	}
}