#include <iostream>
using namespace std;

typedef long long ull;

ull gcd(ull b, ull d, ull &x, ull &y)
{
	if (!b)
	{
		x = 0;
		y = 1;
		return d;
	}

	ull x1, y1, g = gcd(d % b, b, x1, y1);
	x = y1 - (d / b) * x1;
	y = x1;
	
	return g;
}

void any(ull b, ull d, ull &x0, ull &y0, ull &g)
{
	g = gcd(b, d, x0, y0);

	x0 *= b * b / g;
	y0 *= b * b / g;
}

void shift(ull &x, ull &y, ull b, ull d, ull k)
{
	x += k * d;
	y -= k * b;
}

ull min_k(ull b, ull d)
{
	ull x, y, x0, y0, g, k = (b > d) ? -1 : 1;

	g = gcd(b, d, x, y);
	any(b, d, x, y, g);

	x0 = x;
	y0 = y;

	while (x <= 0 || y <= 0)
		shift(x, y, b / g, d / g, k);

	return (y - y0) / (b / g);
}

ull amount(ull b, ull d)
{
	ull c = 0, x, y, g, k = min_k(b, d), f = (b > d) ? -1 : 1;

	g = gcd(b, d, x, y);
	any(b, d, x, y, g);
	shift(x, y, b / g, d / g, -k);

	while (x > 0 && y > 0)
	{
		shift(x, y, b / g, d / g, f);
		c++;
	}

	return c;
}

int main()
{
	int n;
	ull b, d;

	cin >> n;

	for (int i = 0; i < n; i++)
	{
		cin >> b >> d;
		cout << amount(b, d) << endl;
	}

	return 0;
}